--
-- Schema generated by Libformed
-- Wed, 2018-09-05 10:38:32 +0000
-- # Revision: $Revision: 8dcc83c778ca $
--
-- # tables: 7
--
BEGIN;
--
-- DROP TABLES
--
-- DROP TABLE rg_gruppenangebote_tbl CASCADE;
-- DROP TABLE master_tbl CASCADE;
-- DROP TABLE phase_tbl CASCADE;
-- DROP TABLE schulform_tbl CASCADE;
-- DROP TABLE schriftliche_kooperationsvereinbarung_tbl CASCADE;
-- DROP TABLE klassenstufe_6_tbl CASCADE;
-- DROP TABLE ort_gruppenangebot_tbl CASCADE;

--
-- CREATE TABLES
--
CREATE TABLE ort_gruppenangebot_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(67) NOT NULL
);
CREATE TABLE klassenstufe_6_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE schriftliche_kooperationsvereinbarung_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(13) NOT NULL
);
CREATE TABLE schulform_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(48) NOT NULL
);
CREATE TABLE phase_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    value VARCHAR(18) NOT NULL
);
CREATE TABLE master_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    uuid_id CHAR(36),
    bearbeiter_id int NOT NULL,
    fkz VARCHAR(60),
    phase INTEGER DEFAULT -1,
    name_der_schule VARCHAR(60),
    schulform INTEGER DEFAULT -1,
    schulform_nennung_sonstige VARCHAR(60),
    schriftliche_kooperationsvereinbarung INTEGER DEFAULT -1,
    weitere_angaben_kooperationsvereinbarung TEXT,
    datum_begin_kooperation DATE,
    datum_ende_kooperation DATE,
    praeventionskonzept_vorhanden INTEGER DEFAULT -1,
    weitere_angaben_praeventionskonzept TEXT,
    UNIQUE (uuid_id),
    FOREIGN KEY (phase) REFERENCES phase_tbl (id),
    FOREIGN KEY (schulform) REFERENCES schulform_tbl (id),
    FOREIGN KEY (schriftliche_kooperationsvereinbarung) REFERENCES schriftliche_kooperationsvereinbarung_tbl (id),
    FOREIGN KEY (praeventionskonzept_vorhanden) REFERENCES schriftliche_kooperationsvereinbarung_tbl (id)
);
CREATE TABLE rg_gruppenangebote_tbl (
    id SERIAL PRIMARY KEY NOT NULL,
    master_id INTEGER NOT NULL,
    uuid_id CHAR(36),
    name_gruppenangebot VARCHAR(60),
    anzahl_teilnehmer_maennlich INTEGER,
    anzahl_teilnehmer_weiblich INTEGER,
    klassenstufe_6 INTEGER DEFAULT -1,
    klassenstufe_7 INTEGER DEFAULT -1,
    klassenstufe_8 INTEGER DEFAULT -1,
    klassenstufe_9 INTEGER DEFAULT -1,
    klassenstufe_10 INTEGER DEFAULT -1,
    klassenstufe_11 INTEGER DEFAULT -1,
    klassenstufe_12 INTEGER DEFAULT -1,
    klassenstufe_13 INTEGER DEFAULT -1,
    thema_interkulturelle_kompetenz INTEGER DEFAULT -1,
    thema_geschlechter_reflektierte_arbeit INTEGER DEFAULT -1,
    thema_interreligioese_kompetenz INTEGER DEFAULT -1,
    thema_staerkung_der_selbtswirksamkeit INTEGER DEFAULT -1,
    thema_soziale_kompetenz INTEGER DEFAULT -1,
    thema_demokratiebildung INTEGER DEFAULT -1,
    thema_medienkompetenz INTEGER DEFAULT -1,
    thema_auseinandersetzung_mit_dem_islam INTEGER DEFAULT -1,
    thema_antisemitismus INTEGER DEFAULT -1,
    thema_islamfeindlichkeit INTEGER DEFAULT -1,
    thema_anti_homophobie INTEGER DEFAULT -1,
    thema_resilienz_gegenueber_menschfeindlichen_ideologien INTEGER DEFAULT -1,
    thema_religioeses_mobbing INTEGER DEFAULT -1,
    thema_sonstiges INTEGER DEFAULT -1,
    thema_nennung_sonstiges VARCHAR(60),
    format_ag INTEGER DEFAULT -1,
    format_ausflug INTEGER DEFAULT -1,
    format_klassenfahrt INTEGER DEFAULT -1,
    format_veranstaltung INTEGER DEFAULT -1,
    format_veranstaltungsreihe INTEGER DEFAULT -1,
    format_sonstiges INTEGER DEFAULT -1,
    ort_gruppenangebot INTEGER DEFAULT -1,
    format_nennung_sonstiges VARCHAR(60),
    datum_start_gruppenangebot DATE,
    datum_ende_gruppenangebot DATE,
    anbieter_politische_bildung INTEGER DEFAULT -1,
    anbieter_extremismuspraevention INTEGER DEFAULT -1,
    anbieter_sonstiges INTEGER DEFAULT -1,
    anbieter_nennung_sonstiges VARCHAR(60),
    weitere_angaben_gruppenangebot TEXT,
    anzahl_individuelle_beratungen INTEGER,
    FOREIGN KEY (master_id) REFERENCES master_tbl (id) ON DELETE CASCADE,
    UNIQUE (uuid_id),
    FOREIGN KEY (klassenstufe_6) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (klassenstufe_7) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (klassenstufe_8) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (klassenstufe_9) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (klassenstufe_10) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (klassenstufe_11) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (klassenstufe_12) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (klassenstufe_13) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_interkulturelle_kompetenz) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_geschlechter_reflektierte_arbeit) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_interreligioese_kompetenz) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_staerkung_der_selbtswirksamkeit) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_soziale_kompetenz) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_demokratiebildung) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_medienkompetenz) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_auseinandersetzung_mit_dem_islam) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_antisemitismus) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_islamfeindlichkeit) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_anti_homophobie) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_resilienz_gegenueber_menschfeindlichen_ideologien) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_religioeses_mobbing) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (thema_sonstiges) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (format_ag) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (format_ausflug) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (format_klassenfahrt) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (format_veranstaltung) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (format_veranstaltungsreihe) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (format_sonstiges) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (ort_gruppenangebot) REFERENCES ort_gruppenangebot_tbl (id),
    FOREIGN KEY (anbieter_politische_bildung) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (anbieter_extremismuspraevention) REFERENCES klassenstufe_6_tbl (id),
    FOREIGN KEY (anbieter_sonstiges) REFERENCES klassenstufe_6_tbl (id)
);

--
-- INSERT DATA
--
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (1, 'In den Räumlichkeiten der Schule');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (2, 'Außerhalb der Räumlichkeiten der Schule');
INSERT INTO ort_gruppenangebot_tbl (id, value) VALUES (3, 'Teilweise in und teilweise außerhalb der Räumlichkeiten der Schule');

INSERT INTO klassenstufe_6_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO klassenstufe_6_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO klassenstufe_6_tbl (id, value) VALUES (1, 'Ja');

INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (0, 'Nein');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (1, 'Ja');
INSERT INTO schriftliche_kooperationsvereinbarung_tbl (id, value) VALUES (2, 'in Aussicht');

INSERT INTO schulform_tbl (id, value) VALUES (-3, 'Unbekannt');
INSERT INTO schulform_tbl (id, value) VALUES (-2, 'sonstige Schule');
INSERT INTO schulform_tbl (id, value) VALUES (-1, 'Keine Angabe');
INSERT INTO schulform_tbl (id, value) VALUES (1, 'Förderschule');
INSERT INTO schulform_tbl (id, value) VALUES (2, 'Hauptschule');
INSERT INTO schulform_tbl (id, value) VALUES (3, 'Realschule');
INSERT INTO schulform_tbl (id, value) VALUES (4, 'Schularten mit drei Bildungsgängen/Gesamtschule');
INSERT INTO schulform_tbl (id, value) VALUES (5, 'Gymnasium');
INSERT INTO schulform_tbl (id, value) VALUES (6, 'Berufsschule');
INSERT INTO schulform_tbl (id, value) VALUES (7, 'Berufsvorbereitungsjahr (BVJ)');
INSERT INTO schulform_tbl (id, value) VALUES (8, 'Berufsgrundbildungsjahr (BGJ)');
INSERT INTO schulform_tbl (id, value) VALUES (9, 'Berufskolleg');
INSERT INTO schulform_tbl (id, value) VALUES (10, 'Grundschule');
INSERT INTO schulform_tbl (id, value) VALUES (11, 'Schularten mit zwei Bildungsgängen');

INSERT INTO phase_tbl (id, value) VALUES (-1, 'Unbekannt');
INSERT INTO phase_tbl (id, value) VALUES (0, 'Erfassung läuft');
INSERT INTO phase_tbl (id, value) VALUES (1, 'Erfassung beendet');


--
-- GRANTS ON TABLES
--
GRANT SELECT ON ort_gruppenangebot_tbl TO GROUP :cm_group;
GRANT SELECT ON ort_gruppenangebot_tbl TO GROUP :admin_group;
GRANT SELECT ON klassenstufe_6_tbl TO GROUP :cm_group;
GRANT SELECT ON klassenstufe_6_tbl TO GROUP :admin_group;
GRANT SELECT ON schriftliche_kooperationsvereinbarung_tbl TO GROUP :cm_group;
GRANT SELECT ON schriftliche_kooperationsvereinbarung_tbl TO GROUP :admin_group;
GRANT SELECT ON schulform_tbl TO GROUP :cm_group;
GRANT SELECT ON schulform_tbl TO GROUP :admin_group;
GRANT SELECT ON phase_tbl TO GROUP :cm_group;
GRANT SELECT ON phase_tbl TO GROUP :admin_group;
--
--
-- views for master table and repeat groups
--
CREATE OR REPLACE VIEW master_tbl_view
AS SELECT 
     master_tbl.id AS id,
     master_tbl.uuid_id AS uuid_id,
     master_tbl.bearbeiter_id AS bearbeiter_id,
     master_tbl.fkz AS fkz,
     master_tbl.phase AS phase,
     master_tbl.name_der_schule AS name_der_schule,
     master_tbl.schulform AS schulform,
     master_tbl.schulform_nennung_sonstige AS schulform_nennung_sonstige,
     master_tbl.schriftliche_kooperationsvereinbarung AS schriftliche_kooperationsvereinbarung,
     master_tbl.weitere_angaben_kooperationsvereinbarung AS weitere_angaben_kooperationsvereinbarung,
     master_tbl.datum_begin_kooperation AS datum_begin_kooperation,
     master_tbl.datum_ende_kooperation AS datum_ende_kooperation,
     master_tbl.praeventionskonzept_vorhanden AS praeventionskonzept_vorhanden,
     master_tbl.weitere_angaben_praeventionskonzept AS weitere_angaben_praeventionskonzept,
     ( COALESCE( (SELECT SUM( COALESCE( anzahl_individuelle_beratungen , 0 ) ) FROM rg_gruppenangebote_tbl rg WHERE rg.master_id = master_tbl.id ) , 0 ) ) as individuelle_beratungen_gesamt
FROM master_tbl
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE master_tbl_update_rule AS ON UPDATE TO master_tbl_view
DO INSTEAD UPDATE master_tbl SET
    phase = NEW.phase,
    name_der_schule = NEW.name_der_schule,
    schulform = NEW.schulform,
    schulform_nennung_sonstige = NEW.schulform_nennung_sonstige,
    schriftliche_kooperationsvereinbarung = NEW.schriftliche_kooperationsvereinbarung,
    weitere_angaben_kooperationsvereinbarung = NEW.weitere_angaben_kooperationsvereinbarung,
    datum_begin_kooperation = NEW.datum_begin_kooperation,
    datum_ende_kooperation = NEW.datum_ende_kooperation,
    praeventionskonzept_vorhanden = NEW.praeventionskonzept_vorhanden,
    weitere_angaben_praeventionskonzept = NEW.weitere_angaben_praeventionskonzept
WHERE id = NEW.id;

CREATE OR REPLACE RULE master_tbl_delete_rule AS ON DELETE TO master_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_insert_rule AS ON INSERT TO master_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON master_tbl_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW master_tbl_anonym_view
AS SELECT
    master_tbl.id AS id,
    NULL::CHAR(36) AS uuid_id,
    master_tbl.bearbeiter_id AS bearbeiter_id,
    master_tbl.fkz AS fkz,
    master_tbl.phase AS phase,
    NULL::VARCHAR(60) AS name_der_schule,
    master_tbl.schulform AS schulform,
    master_tbl.schulform_nennung_sonstige AS schulform_nennung_sonstige,
    master_tbl.schriftliche_kooperationsvereinbarung AS schriftliche_kooperationsvereinbarung,
    NULL::TEXT AS weitere_angaben_kooperationsvereinbarung,
    master_tbl.datum_begin_kooperation AS datum_begin_kooperation,
    master_tbl.datum_ende_kooperation AS datum_ende_kooperation,
    master_tbl.praeventionskonzept_vorhanden AS praeventionskonzept_vorhanden,
    NULL::TEXT AS weitere_angaben_praeventionskonzept,
    master_tbl.individuelle_beratungen_gesamt AS individuelle_beratungen_gesamt FROM master_tbl_view master_tbl
    INNER JOIN ka_status_tbl s ON master_tbl.id = s.master_id
    WHERE  s.status <> 3;

CREATE OR REPLACE RULE master_tbl_anonym_delete_rule AS ON DELETE TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE master_tbl_anonym_insert_rule AS ON INSERT TO master_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON master_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON master_tbl_anonym_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_gruppenangebote_tbl_view
AS SELECT 
     rg_gruppenangebote_tbl.id AS id,
     rg_gruppenangebote_tbl.master_id AS master_id,
     rg_gruppenangebote_tbl.uuid_id AS uuid_id,
     rg_gruppenangebote_tbl.name_gruppenangebot AS name_gruppenangebot,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_maennlich AS anzahl_teilnehmer_maennlich,
     rg_gruppenangebote_tbl.anzahl_teilnehmer_weiblich AS anzahl_teilnehmer_weiblich,
     rg_gruppenangebote_tbl.klassenstufe_6 AS klassenstufe_6,
     rg_gruppenangebote_tbl.klassenstufe_7 AS klassenstufe_7,
     rg_gruppenangebote_tbl.klassenstufe_8 AS klassenstufe_8,
     rg_gruppenangebote_tbl.klassenstufe_9 AS klassenstufe_9,
     rg_gruppenangebote_tbl.klassenstufe_10 AS klassenstufe_10,
     rg_gruppenangebote_tbl.klassenstufe_11 AS klassenstufe_11,
     rg_gruppenangebote_tbl.klassenstufe_12 AS klassenstufe_12,
     rg_gruppenangebote_tbl.klassenstufe_13 AS klassenstufe_13,
     rg_gruppenangebote_tbl.thema_interkulturelle_kompetenz AS thema_interkulturelle_kompetenz,
     rg_gruppenangebote_tbl.thema_geschlechter_reflektierte_arbeit AS thema_geschlechter_reflektierte_arbeit,
     rg_gruppenangebote_tbl.thema_interreligioese_kompetenz AS thema_interreligioese_kompetenz,
     rg_gruppenangebote_tbl.thema_staerkung_der_selbtswirksamkeit AS thema_staerkung_der_selbtswirksamkeit,
     rg_gruppenangebote_tbl.thema_soziale_kompetenz AS thema_soziale_kompetenz,
     rg_gruppenangebote_tbl.thema_demokratiebildung AS thema_demokratiebildung,
     rg_gruppenangebote_tbl.thema_medienkompetenz AS thema_medienkompetenz,
     rg_gruppenangebote_tbl.thema_auseinandersetzung_mit_dem_islam AS thema_auseinandersetzung_mit_dem_islam,
     rg_gruppenangebote_tbl.thema_antisemitismus AS thema_antisemitismus,
     rg_gruppenangebote_tbl.thema_islamfeindlichkeit AS thema_islamfeindlichkeit,
     rg_gruppenangebote_tbl.thema_anti_homophobie AS thema_anti_homophobie,
     rg_gruppenangebote_tbl.thema_resilienz_gegenueber_menschfeindlichen_ideologien AS thema_resilienz_gegenueber_menschfeindlichen_ideologien,
     rg_gruppenangebote_tbl.thema_religioeses_mobbing AS thema_religioeses_mobbing,
     rg_gruppenangebote_tbl.thema_sonstiges AS thema_sonstiges,
     rg_gruppenangebote_tbl.thema_nennung_sonstiges AS thema_nennung_sonstiges,
     rg_gruppenangebote_tbl.format_ag AS format_ag,
     rg_gruppenangebote_tbl.format_ausflug AS format_ausflug,
     rg_gruppenangebote_tbl.format_klassenfahrt AS format_klassenfahrt,
     rg_gruppenangebote_tbl.format_veranstaltung AS format_veranstaltung,
     rg_gruppenangebote_tbl.format_veranstaltungsreihe AS format_veranstaltungsreihe,
     rg_gruppenangebote_tbl.format_sonstiges AS format_sonstiges,
     rg_gruppenangebote_tbl.ort_gruppenangebot AS ort_gruppenangebot,
     rg_gruppenangebote_tbl.format_nennung_sonstiges AS format_nennung_sonstiges,
     rg_gruppenangebote_tbl.datum_start_gruppenangebot AS datum_start_gruppenangebot,
     rg_gruppenangebote_tbl.datum_ende_gruppenangebot AS datum_ende_gruppenangebot,
     rg_gruppenangebote_tbl.anbieter_politische_bildung AS anbieter_politische_bildung,
     rg_gruppenangebote_tbl.anbieter_extremismuspraevention AS anbieter_extremismuspraevention,
     rg_gruppenangebote_tbl.anbieter_sonstiges AS anbieter_sonstiges,
     rg_gruppenangebote_tbl.anbieter_nennung_sonstiges AS anbieter_nennung_sonstiges,
     rg_gruppenangebote_tbl.weitere_angaben_gruppenangebot AS weitere_angaben_gruppenangebot,
     rg_gruppenangebote_tbl.anzahl_individuelle_beratungen AS anzahl_individuelle_beratungen
FROM rg_gruppenangebote_tbl
    INNER JOIN master_tbl
    ON         rg_gruppenangebote_tbl.master_id = master_tbl.id
WHERE
    master_tbl.bearbeiter_id = getuserid()
    OR master_tbl.id IN (
        SELECT nm.master_id from nm_benutzer_master_tbl nm
        WHERE nm.benutzer_id IN (
            SELECT nm2.gruppe_id from nm_benutzer_gruppe_tbl nm2
            WHERE nm2.benutzer_id = getuserid()
        )
    )
    OR pg_has_role('admin','MEMBER');

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_update_rule AS ON UPDATE TO rg_gruppenangebote_tbl_view
DO INSTEAD UPDATE rg_gruppenangebote_tbl SET
    name_gruppenangebot = NEW.name_gruppenangebot,
    anzahl_teilnehmer_maennlich = NEW.anzahl_teilnehmer_maennlich,
    anzahl_teilnehmer_weiblich = NEW.anzahl_teilnehmer_weiblich,
    klassenstufe_6 = NEW.klassenstufe_6,
    klassenstufe_7 = NEW.klassenstufe_7,
    klassenstufe_8 = NEW.klassenstufe_8,
    klassenstufe_9 = NEW.klassenstufe_9,
    klassenstufe_10 = NEW.klassenstufe_10,
    klassenstufe_11 = NEW.klassenstufe_11,
    klassenstufe_12 = NEW.klassenstufe_12,
    klassenstufe_13 = NEW.klassenstufe_13,
    thema_interkulturelle_kompetenz = NEW.thema_interkulturelle_kompetenz,
    thema_geschlechter_reflektierte_arbeit = NEW.thema_geschlechter_reflektierte_arbeit,
    thema_interreligioese_kompetenz = NEW.thema_interreligioese_kompetenz,
    thema_staerkung_der_selbtswirksamkeit = NEW.thema_staerkung_der_selbtswirksamkeit,
    thema_soziale_kompetenz = NEW.thema_soziale_kompetenz,
    thema_demokratiebildung = NEW.thema_demokratiebildung,
    thema_medienkompetenz = NEW.thema_medienkompetenz,
    thema_auseinandersetzung_mit_dem_islam = NEW.thema_auseinandersetzung_mit_dem_islam,
    thema_antisemitismus = NEW.thema_antisemitismus,
    thema_islamfeindlichkeit = NEW.thema_islamfeindlichkeit,
    thema_anti_homophobie = NEW.thema_anti_homophobie,
    thema_resilienz_gegenueber_menschfeindlichen_ideologien = NEW.thema_resilienz_gegenueber_menschfeindlichen_ideologien,
    thema_religioeses_mobbing = NEW.thema_religioeses_mobbing,
    thema_sonstiges = NEW.thema_sonstiges,
    thema_nennung_sonstiges = NEW.thema_nennung_sonstiges,
    format_ag = NEW.format_ag,
    format_ausflug = NEW.format_ausflug,
    format_klassenfahrt = NEW.format_klassenfahrt,
    format_veranstaltung = NEW.format_veranstaltung,
    format_veranstaltungsreihe = NEW.format_veranstaltungsreihe,
    format_sonstiges = NEW.format_sonstiges,
    ort_gruppenangebot = NEW.ort_gruppenangebot,
    format_nennung_sonstiges = NEW.format_nennung_sonstiges,
    datum_start_gruppenangebot = NEW.datum_start_gruppenangebot,
    datum_ende_gruppenangebot = NEW.datum_ende_gruppenangebot,
    anbieter_politische_bildung = NEW.anbieter_politische_bildung,
    anbieter_extremismuspraevention = NEW.anbieter_extremismuspraevention,
    anbieter_sonstiges = NEW.anbieter_sonstiges,
    anbieter_nennung_sonstiges = NEW.anbieter_nennung_sonstiges,
    weitere_angaben_gruppenangebot = NEW.weitere_angaben_gruppenangebot,
    anzahl_individuelle_beratungen = NEW.anzahl_individuelle_beratungen
WHERE id = NEW.id;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_delete_rule AS ON DELETE TO rg_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_insert_rule AS ON INSERT TO rg_gruppenangebote_tbl_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT UPDATE ON rg_gruppenangebote_tbl_view TO GROUP :cm_group;
GRANT SELECT ON rg_gruppenangebote_tbl_view TO GROUP :admin_group;

CREATE OR REPLACE VIEW rg_gruppenangebote_tbl_anonym_view
AS SELECT
    rg_gruppenangebote_tbl.id AS id,
    rg_gruppenangebote_tbl.master_id AS master_id,
    NULL::CHAR(36) AS uuid_id,
    NULL::VARCHAR(60) AS name_gruppenangebot,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_maennlich AS anzahl_teilnehmer_maennlich,
    rg_gruppenangebote_tbl.anzahl_teilnehmer_weiblich AS anzahl_teilnehmer_weiblich,
    rg_gruppenangebote_tbl.klassenstufe_6 AS klassenstufe_6,
    rg_gruppenangebote_tbl.klassenstufe_7 AS klassenstufe_7,
    rg_gruppenangebote_tbl.klassenstufe_8 AS klassenstufe_8,
    rg_gruppenangebote_tbl.klassenstufe_9 AS klassenstufe_9,
    rg_gruppenangebote_tbl.klassenstufe_10 AS klassenstufe_10,
    rg_gruppenangebote_tbl.klassenstufe_11 AS klassenstufe_11,
    rg_gruppenangebote_tbl.klassenstufe_12 AS klassenstufe_12,
    rg_gruppenangebote_tbl.klassenstufe_13 AS klassenstufe_13,
    rg_gruppenangebote_tbl.thema_interkulturelle_kompetenz AS thema_interkulturelle_kompetenz,
    rg_gruppenangebote_tbl.thema_geschlechter_reflektierte_arbeit AS thema_geschlechter_reflektierte_arbeit,
    rg_gruppenangebote_tbl.thema_interreligioese_kompetenz AS thema_interreligioese_kompetenz,
    rg_gruppenangebote_tbl.thema_staerkung_der_selbtswirksamkeit AS thema_staerkung_der_selbtswirksamkeit,
    rg_gruppenangebote_tbl.thema_soziale_kompetenz AS thema_soziale_kompetenz,
    rg_gruppenangebote_tbl.thema_demokratiebildung AS thema_demokratiebildung,
    rg_gruppenangebote_tbl.thema_medienkompetenz AS thema_medienkompetenz,
    rg_gruppenangebote_tbl.thema_auseinandersetzung_mit_dem_islam AS thema_auseinandersetzung_mit_dem_islam,
    rg_gruppenangebote_tbl.thema_antisemitismus AS thema_antisemitismus,
    rg_gruppenangebote_tbl.thema_islamfeindlichkeit AS thema_islamfeindlichkeit,
    rg_gruppenangebote_tbl.thema_anti_homophobie AS thema_anti_homophobie,
    rg_gruppenangebote_tbl.thema_resilienz_gegenueber_menschfeindlichen_ideologien AS thema_resilienz_gegenueber_menschfeindlichen_ideologien,
    rg_gruppenangebote_tbl.thema_religioeses_mobbing AS thema_religioeses_mobbing,
    rg_gruppenangebote_tbl.thema_sonstiges AS thema_sonstiges,
    rg_gruppenangebote_tbl.thema_nennung_sonstiges AS thema_nennung_sonstiges,
    rg_gruppenangebote_tbl.format_ag AS format_ag,
    rg_gruppenangebote_tbl.format_ausflug AS format_ausflug,
    rg_gruppenangebote_tbl.format_klassenfahrt AS format_klassenfahrt,
    rg_gruppenangebote_tbl.format_veranstaltung AS format_veranstaltung,
    rg_gruppenangebote_tbl.format_veranstaltungsreihe AS format_veranstaltungsreihe,
    rg_gruppenangebote_tbl.format_sonstiges AS format_sonstiges,
    rg_gruppenangebote_tbl.ort_gruppenangebot AS ort_gruppenangebot,
    rg_gruppenangebote_tbl.format_nennung_sonstiges AS format_nennung_sonstiges,
    rg_gruppenangebote_tbl.datum_start_gruppenangebot AS datum_start_gruppenangebot,
    rg_gruppenangebote_tbl.datum_ende_gruppenangebot AS datum_ende_gruppenangebot,
    rg_gruppenangebote_tbl.anbieter_politische_bildung AS anbieter_politische_bildung,
    rg_gruppenangebote_tbl.anbieter_extremismuspraevention AS anbieter_extremismuspraevention,
    rg_gruppenangebote_tbl.anbieter_sonstiges AS anbieter_sonstiges,
    rg_gruppenangebote_tbl.anbieter_nennung_sonstiges AS anbieter_nennung_sonstiges,
    NULL::TEXT AS weitere_angaben_gruppenangebot,
    rg_gruppenangebote_tbl.anzahl_individuelle_beratungen AS anzahl_individuelle_beratungen FROM rg_gruppenangebote_tbl
    INNER JOIN master_tbl_anonym_view
    ON   rg_gruppenangebote_tbl.master_id = master_tbl_anonym_view.id
 ;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_anonym_delete_rule AS ON DELETE TO rg_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

CREATE OR REPLACE RULE rg_gruppenangebote_tbl_anonym_insert_rule AS ON INSERT TO rg_gruppenangebote_tbl_anonym_view
    DO INSTEAD NOTHING;

GRANT SELECT ON rg_gruppenangebote_tbl_anonym_view TO GROUP :cm_group;
GRANT SELECT ON rg_gruppenangebote_tbl_anonym_view TO GROUP :admin_group;

--
-- Function to anonymize a case and all of its repeat groups
--
CREATE OR REPLACE FUNCTION anonymize_case(mid int)
RETURNS void AS
$$
BEGIN
    PERFORM anonymize_uuid(mid);
    -- anonymize master table
    UPDATE master_tbl_view SET
        uuid_id = NULL,
        name_der_schule = NULL,
        weitere_angaben_kooperationsvereinbarung = NULL,
        weitere_angaben_praeventionskonzept = NULL
    WHERE id = mid;

    -- anonymize repeat groups
    UPDATE rg_gruppenangebote_tbl_view SET
        uuid_id = NULL,
        name_gruppenangebot = NULL,
        weitere_angaben_gruppenangebot = NULL
    WHERE master_id = mid;

END;
$$ LANGUAGE plpgsql VOLATILE SECURITY DEFINER;

REVOKE ALL ON FUNCTION anonymize_case(int) FROM public;
GRANT EXECUTE ON FUNCTION anonymize_case(int) TO GROUP :admin_group;

COMMIT;
