
--
-- THIS IS MACHINE GENERATED BY libformed. BE CAREFUL WITH MANUAL EDITING
--
-- Version: $Revision: 0fdbb639be0a $
--
BEGIN;

-- ------ This is static code and therefore may be put into a separate file. -------

-- Used to track the structure changes of a case
-- DROP TABLE case_structure CASCADE;

CREATE TABLE case_structure (
    id        SERIAL PRIMARY KEY NOT NULL,
    master_id int4 NOT NULL REFERENCES master_tbl(id) ON DELETE CASCADE,
    modified  boolean,
    cache     TEXT
);

-- each time a new case is created create a new entry in the strcuture table

-- DROP TRIGGER case_insert_trigger ON master_tbl;
-- DROP FUNCTION case_insert_func();

CREATE OR REPLACE FUNCTION case_insert_func() RETURNS TRIGGER AS $$
BEGIN
    INSERT INTO case_structure (master_id, modified) VALUES (NEW.id, true);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER case_insert_trigger AFTER INSERT ON master_tbl
FOR EACH ROW EXECUTE PROCEDURE case_insert_func();

-- ------ end of static code -------

-- PLPython is an untrusted language. -> Need to be postgres.
SET ROLE postgres;

-- DROP FUNCTION compute_case_structure(int4);
CREATE OR REPLACE FUNCTION compute_case_structure(case_id int4) RETURNS TEXT
AS $$

class Node(object):

    def __init__(self, name, id=None, children=[]):
        self.name = name
        self.id = id
        self.children = children

    def to_json(self, out):
        out.append('{"name":"%s","id":%d' % (self.name, self.id))
        if self.children:
            out.append(',"children":[')
            first = True
            for child in self.children:
                if first:
                    first = False
                else:
                    out.append(",")
                child.to_json(out)
            out.append("]")
        out.append("}")

    def recursive_build(self, mid, children, parent_name="master"):
        select = ("SELECT id FROM %s WHERE %s_id = %d"
                  % (self.name, parent_name, mid))
        ids = [r['id'] for r in plpy.execute(select)]
        for id in ids:
            sub_children = []
            node = Node(self.name, id, sub_children)
            name = self.name[:-4] # cut off trailing '_tbl'
            for child in self.children:
                child.recursive_build(id, sub_children, name)
            children.append(node)

TREE_STRUCTURE = Node('master_tbl', children = [
    Node('rg_kontaktdaten_tbl'),
    Node('rg_kontaktdaten_sorgeberechtigte_tbl'),
    Node('rg_institution_tbl'),
    Node('rg_sprache_zuhause_weitere_tbl'),
    Node('rg_kinder_tbl'),
    Node('rg_biographie2_tbl'),
    Node('rg_weitere_sprache_tbl'),
    Node('rg_ziele_tbl')
])


children = []
tree = Node(TREE_STRUCTURE.name, case_id, children)
for child in TREE_STRUCTURE.children:
    child.recursive_build(case_id, children)
out = []
tree.to_json(out)
return "".join(out)

$$ LANGUAGE plpythonu EXTERNAL SECURITY DEFINER;
ALTER FUNCTION compute_case_structure(int4) OWNER TO :adm_ka_owner;

-- DROP FUNCTION get_case_structure(int4);
CREATE OR REPLACE FUNCTION get_case_structure(case_id int4) RETURNS TEXT AS $$

r = plpy.execute("SELECT modified, cache FROM case_structure "
                 "WHERE master_id = %d" % case_id, 1)

if not r:
    return ""
r = r[0]

if r['modified']: # need refresh
    structure = plpy.execute("SELECT compute_case_structure(%d) as s;"
                             % case_id, 1)[0]["s"]
    plan = plpy.prepare("UPDATE case_structure SET modified = false, "
                        "cache = $1 WHERE master_id = $2", ["text", "int4"])
    plpy.execute(plan, [structure, case_id])
    return structure

return r['cache']

$$ LANGUAGE plpythonu EXTERNAL SECURITY DEFINER;
ALTER FUNCTION get_case_structure(int4) OWNER TO :adm_ka_owner;

-- Continue as db-owner from here
SET ROLE :adm_ka_owner;

--
-- These triggers are used to keep case_structure table in sync.
-- Each time a repeat group is created or deleted the case_structure
-- modified field has to be set to 'true'.
--


-- DROP TRIGGER rg_kontaktdaten_tbl_insert_trigger ON rg_kontaktdaten_tbl CASCADE;
-- DROP FUNCTION rg_kontaktdaten_tbl_insert_func();
-- DROP TRIGGER rg_kontaktdaten_tbl_delete_trigger ON rg_kontaktdaten_tbl CASCADE;
-- DROP FUNCTION rg_kontaktdaten_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_kontaktdaten_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kontaktdaten_tbl_insert_trigger AFTER INSERT ON rg_kontaktdaten_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kontaktdaten_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_kontaktdaten_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_kontaktdaten_tbl_update_trigger AFTER UPDATE ON rg_kontaktdaten_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kontaktdaten_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_kontaktdaten_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kontaktdaten_tbl_delete_trigger AFTER DELETE ON rg_kontaktdaten_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kontaktdaten_tbl_delete_func();

-- DROP TRIGGER rg_kontaktdaten_sorgeberechtigte_tbl_insert_trigger ON rg_kontaktdaten_sorgeberechtigte_tbl CASCADE;
-- DROP FUNCTION rg_kontaktdaten_sorgeberechtigte_tbl_insert_func();
-- DROP TRIGGER rg_kontaktdaten_sorgeberechtigte_tbl_delete_trigger ON rg_kontaktdaten_sorgeberechtigte_tbl CASCADE;
-- DROP FUNCTION rg_kontaktdaten_sorgeberechtigte_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_kontaktdaten_sorgeberechtigte_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kontaktdaten_sorgeberechtigte_tbl_insert_trigger AFTER INSERT ON rg_kontaktdaten_sorgeberechtigte_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kontaktdaten_sorgeberechtigte_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_kontaktdaten_sorgeberechtigte_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_kontaktdaten_sorgeberechtigte_tbl_update_trigger AFTER UPDATE ON rg_kontaktdaten_sorgeberechtigte_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kontaktdaten_sorgeberechtigte_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_kontaktdaten_sorgeberechtigte_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kontaktdaten_sorgeberechtigte_tbl_delete_trigger AFTER DELETE ON rg_kontaktdaten_sorgeberechtigte_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kontaktdaten_sorgeberechtigte_tbl_delete_func();

-- DROP TRIGGER rg_institution_tbl_insert_trigger ON rg_institution_tbl CASCADE;
-- DROP FUNCTION rg_institution_tbl_insert_func();
-- DROP TRIGGER rg_institution_tbl_delete_trigger ON rg_institution_tbl CASCADE;
-- DROP FUNCTION rg_institution_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_institution_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_institution_tbl_insert_trigger AFTER INSERT ON rg_institution_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_institution_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_institution_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_institution_tbl_update_trigger AFTER UPDATE ON rg_institution_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_institution_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_institution_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_institution_tbl_delete_trigger AFTER DELETE ON rg_institution_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_institution_tbl_delete_func();

-- DROP TRIGGER rg_sprache_zuhause_weitere_tbl_insert_trigger ON rg_sprache_zuhause_weitere_tbl CASCADE;
-- DROP FUNCTION rg_sprache_zuhause_weitere_tbl_insert_func();
-- DROP TRIGGER rg_sprache_zuhause_weitere_tbl_delete_trigger ON rg_sprache_zuhause_weitere_tbl CASCADE;
-- DROP FUNCTION rg_sprache_zuhause_weitere_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_sprache_zuhause_weitere_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_sprache_zuhause_weitere_tbl_insert_trigger AFTER INSERT ON rg_sprache_zuhause_weitere_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_sprache_zuhause_weitere_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_sprache_zuhause_weitere_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_sprache_zuhause_weitere_tbl_update_trigger AFTER UPDATE ON rg_sprache_zuhause_weitere_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_sprache_zuhause_weitere_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_sprache_zuhause_weitere_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_sprache_zuhause_weitere_tbl_delete_trigger AFTER DELETE ON rg_sprache_zuhause_weitere_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_sprache_zuhause_weitere_tbl_delete_func();

-- DROP TRIGGER rg_kinder_tbl_insert_trigger ON rg_kinder_tbl CASCADE;
-- DROP FUNCTION rg_kinder_tbl_insert_func();
-- DROP TRIGGER rg_kinder_tbl_delete_trigger ON rg_kinder_tbl CASCADE;
-- DROP FUNCTION rg_kinder_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_kinder_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kinder_tbl_insert_trigger AFTER INSERT ON rg_kinder_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kinder_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_kinder_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_kinder_tbl_update_trigger AFTER UPDATE ON rg_kinder_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kinder_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_kinder_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_kinder_tbl_delete_trigger AFTER DELETE ON rg_kinder_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_kinder_tbl_delete_func();

-- DROP TRIGGER rg_biographie2_tbl_insert_trigger ON rg_biographie2_tbl CASCADE;
-- DROP FUNCTION rg_biographie2_tbl_insert_func();
-- DROP TRIGGER rg_biographie2_tbl_delete_trigger ON rg_biographie2_tbl CASCADE;
-- DROP FUNCTION rg_biographie2_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_biographie2_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_biographie2_tbl_insert_trigger AFTER INSERT ON rg_biographie2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_biographie2_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_biographie2_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_biographie2_tbl_update_trigger AFTER UPDATE ON rg_biographie2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_biographie2_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_biographie2_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_biographie2_tbl_delete_trigger AFTER DELETE ON rg_biographie2_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_biographie2_tbl_delete_func();

-- DROP TRIGGER rg_weitere_sprache_tbl_insert_trigger ON rg_weitere_sprache_tbl CASCADE;
-- DROP FUNCTION rg_weitere_sprache_tbl_insert_func();
-- DROP TRIGGER rg_weitere_sprache_tbl_delete_trigger ON rg_weitere_sprache_tbl CASCADE;
-- DROP FUNCTION rg_weitere_sprache_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_weitere_sprache_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_weitere_sprache_tbl_insert_trigger AFTER INSERT ON rg_weitere_sprache_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_weitere_sprache_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_weitere_sprache_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_weitere_sprache_tbl_update_trigger AFTER UPDATE ON rg_weitere_sprache_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_weitere_sprache_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_weitere_sprache_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_weitere_sprache_tbl_delete_trigger AFTER DELETE ON rg_weitere_sprache_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_weitere_sprache_tbl_delete_func();

-- DROP TRIGGER rg_ziele_tbl_insert_trigger ON rg_ziele_tbl CASCADE;
-- DROP FUNCTION rg_ziele_tbl_insert_func();
-- DROP TRIGGER rg_ziele_tbl_delete_trigger ON rg_ziele_tbl CASCADE;
-- DROP FUNCTION rg_ziele_tbl_delete_func();

CREATE OR REPLACE FUNCTION rg_ziele_tbl_insert_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_ziele_tbl_insert_trigger AFTER INSERT ON rg_ziele_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_ziele_tbl_insert_func();

CREATE OR REPLACE FUNCTION rg_ziele_tbl_update_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid NEW.master_id;
    PERFORM set_lastaccess_time(mid);
    RETURN NEW;
END;
$$ LANGUAGE plpgsql EXTERNAL SECURITY DEFINER;

CREATE TRIGGER rg_ziele_tbl_update_trigger AFTER UPDATE ON rg_ziele_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_ziele_tbl_update_func();

CREATE OR REPLACE FUNCTION rg_ziele_tbl_delete_func() RETURNS TRIGGER AS $$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid OLD.master_id;
    UPDATE case_structure
        SET modified = FALSE, cache = compute_case_structure(master_id)
        WHERE master_id = mid;
    PERFORM set_lastaccess_time(mid);
    RETURN OLD;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER rg_ziele_tbl_delete_trigger AFTER DELETE ON rg_ziele_tbl
    FOR EACH ROW EXECUTE PROCEDURE rg_ziele_tbl_delete_func();



CREATE OR REPLACE FUNCTION create_master_tbl(nuuid char(36))
    RETURNS integer
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    standin integer;
    rid     integer;
BEGIN
    rid := create_master_ds(nuuid);
    IF nuuid IS NULL THEN
        PERFORM create_rg_kontaktdaten_tbl(rid, NULL);
      PERFORM create_rg_kontaktdaten_sorgeberechtigte_tbl(rid, NULL);
      PERFORM create_rg_institution_tbl(rid, NULL);
      PERFORM create_rg_ziele_tbl(rid, NULL);
    END IF;

    RETURN rid;
END;
$$;

REVOKE ALL ON FUNCTION create_master_tbl(char(36)) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION create_master_tbl(char(36))
    TO GROUP :cm_group;

CREATE OR REPLACE FUNCTION delete_master_tbl(mid integer) RETURNS void
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER
    AS $$
DECLARE
    st integer;
BEGIN
    SELECT INTO st s.status FROM master_tbl m JOIN ka_status_tbl s
        ON s.master_id = m.id WHERE m.id = mid;

    IF NOT st in (3, 5) THEN
        RAISE EXCEPTION 'case is not deletable';
    END IF;

    DELETE FROM master_tbl WHERE id = mid;
END;
$$;

REVOKE ALL ON FUNCTION delete_master_tbl(integer) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION delete_master_tbl(integer)
    TO GROUP :admin_group;

CREATE OR REPLACE FUNCTION create_rg_kontaktdaten_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_kontaktdaten_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_kontaktdaten_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_kontaktdaten_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_kontaktdaten_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_kontaktdaten_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_kontaktdaten_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_kontaktdaten_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_kontaktdaten_sorgeberechtigte_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_kontaktdaten_sorgeberechtigte_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_kontaktdaten_sorgeberechtigte_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_kontaktdaten_sorgeberechtigte_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_kontaktdaten_sorgeberechtigte_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_kontaktdaten_sorgeberechtigte_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_kontaktdaten_sorgeberechtigte_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_kontaktdaten_sorgeberechtigte_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_institution_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_institution_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_institution_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_institution_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_institution_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_institution_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_institution_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_institution_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_sprache_zuhause_weitere_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_sprache_zuhause_weitere_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_sprache_zuhause_weitere_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_sprache_zuhause_weitere_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_sprache_zuhause_weitere_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_sprache_zuhause_weitere_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_sprache_zuhause_weitere_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_sprache_zuhause_weitere_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_kinder_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_kinder_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_kinder_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_kinder_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_kinder_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_kinder_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_kinder_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_kinder_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_biographie2_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_biographie2_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_biographie2_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_biographie2_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_biographie2_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_biographie2_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_biographie2_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_biographie2_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_weitere_sprache_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_weitere_sprache_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_weitere_sprache_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_weitere_sprache_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_weitere_sprache_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_weitere_sprache_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_weitere_sprache_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_weitere_sprache_tbl WHERE id = rid;
END;
$$;

CREATE OR REPLACE FUNCTION create_rg_ziele_tbl(pid integer, nuuid char(36))
RETURNS integer
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    rid integer;
    mid integer;
BEGIN
    mid := pid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    INSERT INTO rg_ziele_tbl (master_id) VALUES (pid);

    SELECT INTO rid currval('rg_ziele_tbl_id_seq');

    IF nuuid IS NOT NULL THEN
        UPDATE rg_ziele_tbl
        SET    uuid_id = nuuid
        WHERE  id = rid;
    ELSE
        PERFORM set_uuid('rg_ziele_tbl', rid);
        
    END IF;

    RETURN rid;
END;
$$;

CREATE OR REPLACE FUNCTION delete_rg_ziele_tbl(rid integer)
RETURNS void
LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    mid integer;
BEGIN
    SELECT INTO mid master_id FROM rg_ziele_tbl WHERE id = rid;

    IF NOT isEditorOrStandin(mid) THEN
        RAISE EXCEPTION 'DS ID not session_user ID';
    END IF;

    DELETE FROM rg_ziele_tbl WHERE id = rid;
END;
$$;


COMMIT;

