BEGIN;
-- issue2085: create new rg by default
SET ROLE :db_adm;

INSERT INTO db_history (beschreibung, zeitpunkt)
VALUES ('1.1/06_rg_ziele.sql', current_timestamp);


-- ----------------------------------------------------------
-- Create a new RG entry in rg_ziele for every new case
-- ----------------------------------------------------------
CREATE OR REPLACE FUNCTION create_master_tbl(nuuid char(36))
    RETURNS integer
    LANGUAGE 'plpgsql' VOLATILE EXTERNAL SECURITY DEFINER AS
$$
DECLARE
    standin integer;
    rid     integer;
BEGIN
    rid := create_master_ds(nuuid);
    IF nuuid IS NULL THEN
        PERFORM create_rg_kontaktdaten_tbl(rid, NULL);
      PERFORM create_rg_kontaktdaten_sorgeberechtigte_tbl(rid, NULL);
      PERFORM create_rg_institution_tbl(rid, NULL);
      PERFORM create_rg_ziele_tbl(rid, NULL);
    END IF;

    RETURN rid;
END;
$$;

REVOKE ALL ON FUNCTION create_master_tbl(char(36)) FROM PUBLIC;
GRANT EXECUTE ON FUNCTION create_master_tbl(char(36))
    TO GROUP :cm_group;

--
-- Finish
--
SET ROLE postgres;
COMMIT;

