# -*- coding: utf-8 -*-
#
# Copyright 2018 Intevation GmbH, Germany, <info@intevation.de>
#
# This file is part of mpuls JMD
#
# mpuls JMD is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# mpuls JMD is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with mpuls JMD. If not, see <http://www.gnu.org/licenses/>.
#
# mpuls JMD has been developed on behalf of the
# Projekttraeger im Deutschen Zentrum fuer Luft- und Raumfahrt e.V. (PT-DLR)
# within the programme Kompetenzagenturen (Durchfuehrungsphase) funded by
# the Bundesministerium fuer Familie, Senioren, Frauen und Jugend and
# European Social Fund resources.

import logging

from formencode import ForEach
from formencode.validators import Int

from mpulsweb.lib.search import CaseSearch
from mpulsweb.lib.search import EvaluationSearch as EvaluationBaseSearch
from mpulsweb.lib.search import CaseCountSearch, ExtendedCaseSearch
import mpulsweb.lib.searchexpr as S

log = logging.getLogger(__name__)


class EvaluationSearch(EvaluationBaseSearch):

    SEARCH_FIELDS = (EvaluationBaseSearch.SEARCH_FIELDS
                     | frozenset(["SUM(case_document_count(m.id))"
                                   " AS document_count"]))

# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
