# -*- coding: utf-8 -*-

import logging

from pylons import app_globals as g

from mpulsweb.lib.base import render, c
from mpulsweb.lib.translation import _

from mpulsweb.controllers.privacy import PrivacyController
from mpulsweb.lib.security import checkRole


class PrivacyController(PrivacyController):

    @checkRole('cm')
    def printDiscretionStatement(self, id):
        """Fill and render the discretion statement."""
        id = self._checkInt(id)
        case = self._loadCase(id)
        statement = case.getDiscretionStatement()
        c.content = statement.fillout()
        return render('privacy/default_statement.mako')

    @checkRole('cm')
    def listGenericStatements(self):
        """Render a list of available static statements related to privacy."""
        return render('privacy/list_generic_statements.mako')

# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8:
