## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%!
   import mpulsweb.lib.helper.filters as F
   from mpulsweb.lib.navigation import render_navigation
   from mpulsweb.model.appointment import NextAppointmentOverview
   from jmdweb.model.appointment import automatic_reminders_for_case
%>
${next.body()}

<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li><a href="${h.url(controller='case', action='index')}"
         onclick="return checkModification();">${_('Case Management')}</a></li>
  <li><a href="${h.url(controller='case_overview', action='overview')}" 
         onclick="return checkModification();">${_('Case document overview')}</a></li>
</%def>
<%def name="buildModusfield()">
</%def>

<%def name="buildInfofield()">
  <% case = session.get('case') %>
  <% statemachine = g.case_factory.get_state_machine() %>
  <div id="infofield">
    % for f in g.case.get_infofield_fields():
      ${f.info_label}:
      <strong>${h.shorten(case.get_value(f.alias), 15)  | F.NA}</strong>
      <br>
    % endfor
    <% current_phase = statemachine.get_current_state(case.getState()) %>
    ${_('Phase')}: <strong>${ h.literal(current_phase.get_display_name()) | F.NA}</strong><br>
    ${_('Status')}:
    <strong>${case.getState().getStateLabel()  | F.NA}</strong><br>
  </div>
</%def>

<%def name="buildPrivacyfield()">
  % if g.mpuls_config.is_enabled('case-module', 'privacy'):
    <div class="menu">
    <h1>${_('Data protection')}</h1>
    <ul class="mainMenu" id="mainMenuPrivacy"> <!--ID only because of IE6 -->
        <li>${_('Options')}
            <ul>
                % if session.get('case').getState().getState() not in (3,4,5):
                  % if not session.get('case').hasPrivacyStatement():
                      <li>
                      <a href="${h.url(controller='privacy', action='set',
                                           id=session.get('case').id)}"
                         onclick="return checkModification();">${_('Set statement')}
                      </a>
                      </li>
                  % elif session.get('case').hasPrivacyStatement():
                      <li>
                      <a href="${h.url(controller='privacy',
                                           action='decline', 
                                           id=session.get('case').id,
                                           confirmed=0)}" 
                         onclick="return checkModification();">${_('Revoke Statement')}
                      </a>
                      </li>
                  % endif
                  <li>
                  <a href="${h.url(controller='case',
                                       action='markForAnonymize', 
                                       id=session.get('case').id,
                                       confirmed=0)}" 
                      onclick="return checkModification();">${_('Anonymize case document')}
                  </a>
                  </li>
                % endif
                <li>
                <a href="${h.url(controller='privacy',
                                     action='listStatements')}" 
                   onclick="return checkModification();"> ${_('Available statements')}
                </a>
                </li>
            </ul>
        </li>
    </ul>
    </div>
  % endif
</%def>

<%def name="buildNavigation()">
  <div class="menu">
    <h1>${_('case document')}</h1>
    <div class="actions">
    % if h.hasRole(['cm', 'admin']):
      ${self.buildInfofield()}
      <ul>
        <li>
            <a href="${h.url(controller='case_overview', action='overview')}"
            onclick="return checkModification();">${_('Back to overview')}</a>
        </li>
        <li>
            <a href="${h.url(controller='phase', action='overview',
                                 id=session.get('case').id)}"
               onclick="return checkModification();">${_('Phase in CM')}</a>
        </li>
        % if h.hasRole(['cm']) and g.mpuls_config.is_enabled('case-module', 'logbook'):
            <li>
                <a href="${h.url(controller='logbook',
                                     action='index',
                                     id=session.get('case').id)}" 
                    onclick="return checkModification();">
                    Tagebuch
                </a>
            </li>
        % endif
        % if g.mpuls_config.is_enabled('case-module', 'meta-server') and session.get('case').getState().getState() == 1 and h.hasRole(['cm']):
        <li>
          <a href="${h.url(controller='meta', 
                               action='index', 
                               id=session.get('case').id)}" 
                    onclick="return checkModification();">
                    ${_('Meta case')}
          </a>
        </li>
        % endif
        % if g.mpuls_config.is_enabled('case-module', 'appointments'):
            <li>
                <a href="${h.url(controller='caseappointment',
                                     action='index',
                                     id=session.get('case').id)}" 
                   onclick="return checkModification();">
                    ${_('Appointment/Reminder')}
                </a>
            </li>
        </ul>
        <div id="infofield2">
          <% case = session.get('case') %>
          ${_('Next event')}:
          <% next_appointment = NextAppointmentOverview(caseid=case.id).get_next_appointment() %>
          % if next_appointment and next_appointment.getStartDate():
            <strong><a href="${h.url(controller='caseappointment', action='show', id=next_appointment.id)}" style="display: inline; background-image: none;">${h.format_date(next_appointment.getStartDate().date())}</a></strong><br>
          % else:
            <strong>-/-</strong><br>
          % endif
        </div>
        <div id="infofield2">
          <% case = session.get('case') %>
          ${_('Reminders:')}
          <% reminders = automatic_reminders_for_case(case) %>
          % if reminders:
          % for reminder in reminders:
          <strong>${reminder.title}</strong><br>
          % endfor
          % else:
            <strong>-/-</strong><br>
          % endif
        </div>
        <ul>
        % endif
      </ul>
    % endif
     </div>
    <ul class="mainMenu" id="mainMenuCase"> <!--ID only because of IE6 -->
        <li style="z-index: 10">${_('More options')}
            <ul>
                <li>
                    <a href="${h.url(controller='case', action='digest',
                                         id=session.get('case').id)}" 
                       onclick="return checkModification();">
                        ${_('Summary')}
                    </a>
                </li>
            % if h.hasRole(['cm', 'admin']):
                % if g.mpuls_config.is_enabled('case-module', 'organisation'):
                <li>
                    <a href="${h.url(controller='case', 
                                         action='organisation', 
                                         id=session.get('case').id)}" 
                    onclick="return checkModification();">
                        ${_('Organisation')}
                    </a>
                </li>
                % endif
                % if g.mpuls_config.is_enabled('case-module', 'tags'):
                <li>
                    <a href="${h.url(controller='tags',
                                         action='overview',
                                         id=session.get('case').id)}" 
                       onclick="return checkModification();">
                        ${_('Tags')}
                    </a>
                </li>
                % endif
                % if g.mpuls_config.is_enabled('case-module', 'documents'):
                    <li>
                        <a href="${h.url(controller='casedocument',
                                             action='index',
                                             id=session.get('case').id)}" 
                           onclick="return checkModification();">
                            ${_('documents')}
                        </a>
                    </li>
                % endif
                % if g.mpuls_config.is_enabled('case-module', 'copy') and session.get('case').getState().getState() == 1 and h.hasRole(['cm']):
                <li>
                    <a href="${h.url(controller='case', action='copy', 
                                         id=session.get('case').id,
                                         confirmed=0)}"
                    onclick="return checkModification()">${_('Copy case')}</a>
                </li>
                % endif
                <li>
                    <a href="${h.url(controller='case', action='printAll', 
                                         id=session.get('case').id,
                                         confirmed=0)}"
                    onclick="return checkModification();"
                    target="_blank">${_('Print case document')}</a>
                </li>
                % if g.mpuls_config.is_enabled('case-module', 'statements'):
                  <%include file="/statements/statements.mako" />
                % endif
            % endif
            % if h.hasRole('cm'):
                <li>
                <a href="${h.url(controller='supportplan',
                                 action='print_supportplan',
                                 id=session.get('case').id)}" 
                   onclick="return checkModification();"
                   target="_blank">Integrationsförderplan drucken
                </a>
                </li>
            % endif
            </ul>
        </li>
      </ul>
  </div>
  
  <div class="menu">
    <h1>${_('Structure')}</h1>
    ${h.literal(render_navigation())}
  </div>
</%def>


<%def name="buildUeberschrift()">
</%def>
