## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%
  formular_labels = {'ka_name': _('Name of the institution'),
                     'max_speicherdauer': _('Automatic review after days'),
                     'job_percentage': _('Job Percentage')
                    }
%>
<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li>
    <a href="${h.url(controller='settings', action='index')}">${_('Administration')}</a>
  </li>
  <li>
    <a href="${h.url(controller='settings', action='show')}">${_('Show settings')}</a>
  </li>
  <li>
    <a href="${h.url(controller='settings', action='edit')}">${_('Edit settings')}</a>
  </li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('Edit settings')}
</%def>

<div id="content_header_small">
  <div id="content_ueberschrift">
    ${_('Edit settings')}
  </div>
  <div id="modusfield">
    <div class="actions">
      <ul>
        <li>
          <a href="${h.url(controller='settings',
                               action='show')}">
            ${_('Back to: institution settings')}
          </a>
        </li>
      </ul>
    </div>
  </div>
</div>

${self.buildFormErrors(formular_labels)}
<div id="admin_edit_settings">
  <p>${_('Edit institution settings.')}</p>
  <div class="waska_form">
    <form action="${h.url(controller='settings', action='editAction')}" method="POST">
      ${ h.csrf_token() }
      <fieldset>
        <legend>${_('Specification for agency')}</legend>
        <div class="waska_form_element w30">
          <label for="ka_name">${_('Name of the institution')}</label>
          <input type="text" class="field" id="ka_name" name="ka_name" value="" maxlength="60">
        </div>
        <div class="waska_form_element w30">
          <label for="ka_adresse">${_('Address of the institution')}</label>
          <input type="text" class="field" id="ka_adresse" name="ka_adresse" value="" maxlength="120">
        </div>
      </fieldset>
      <fieldset>
        <legend>${_('Specification for cases')}</legend>
        <div class="waska_form_element w100">
          <label for="max_speicherdauer">
            ${_('Automatic review after days')}
          </label>
          <input type="text" id="max_speicherdauer" name="max_speicherdauer" value="" maxlength="4">
          <p class="info">
            ${_('Automatic reminders are used to identify cases, which has not been edited for longer than the specified value. Additionally there can be further conditions when a reminder is created. Further condition: %s') % c.agency.getReminderConditionDesc()}
          </p>
        </div>
        <div class="waska_form_element w100">
          % if c.form_errors.get('anon_transfer'):
            <a href="#error_list">
              <img class="smallicon" alt="" src="${h.url('/images/icons/info/failure_22.png')}">
            </a>
          % endif
          <input id="anon_transfer" name="anon_transfer" type="checkbox"/>
          <label for="anon_transfer">
            ${_('Assign case document')}
          </label>
          <p>
            ${_('If this option is activated, anonymized cases are transmitted for evaluation purpose to a central agency. Anonymized cases do to not contain any personal data such as name or addresses.')}
          </p>
        </div>
      </fieldset>

      % if g.mpuls_config.is_enabled('job_percentage', 'enabled'):
      <fieldset>
        <legend>${_('Edit job percentage')}</legend>
        <div class="waska_form_element">
          <label for="meta_user_name">
            ${_('Job percentage')}
          </label>
          <input type="text" id="job_percentage" name="job_percentage" value="" maxlength="120"/>
          (${_('Format: X.Y')})
          % if g.mpuls_config.get('job_percentage', 'to_email') != 0:
            <p class="info">
              <% 
                recipient = g.mpuls_config.get('job_percentage', 'recipient')
                if recipient == 0:
                  recipient = g.mpuls_config.get('job_percentage', 'to_email')
              %>
             Bei Änderungen der Stellenanteile wird eine Benachrichtung an "${recipient}" versendet.
            </p>
          % endif
        </div>
      </fieldset>
      % endif

      % if g.mpuls_config.is_enabled('case-module', 'meta-server'):
         <fieldset><legend>${_('Meta connection')}</legend>
	% if c.agency.getMetaUserName() and c.agency.getMetaUserPassword():
	  <p class="ok">${_('Meta connection is configured')}</p>
	   <div class="waska_form_element w100">
          % if c.form_errors.get('meta_transfer'):
            <a href="#error_list">
              <img class="smallicon" alt="" src="${h.url('/images/icons/info/failure_22.png')}">
            </a>
          % endif
          <input id="meta_transfer" name="meta_transfer" type="checkbox"/>
          <label for="meta_transfer">
            ${_('Transfer cases to meta server')}
          </label>
        </div>
	% else:
          <p class="error">${_('Meta connection is not configured. Please contact your administration.')}</p>
	% endif
	  </fieldset>
      % endif
      <div id="admin_edit_settings_submit" class="waska_form_element w100">
        <input class="button" type="submit" value="${_('Save settings')}">
      </div>
    </form>
  </div>
</div>

