# -*- coding: utf-8 -*-
import logging
import calendar
from datetime import date

from pylons.controllers.util import abort

from pylons import app_globals as g, tmpl_context as c
from mpulsweb.lib.base import BaseController, render
from mpulsweb.lib.security import checkRole
from mpulsweb.model.percentage import JobPercentage

log = logging.getLogger(__name__)


class JobpercentageController(BaseController):

    '''Display the jobpercentage of the agencies.'''

    def __before__(self, environ):
        if not g.mpuls_config.is_enabled('job_percentage', 'enabled'):
            abort(404)
        return super(JobpercentageController, self).__before__(environ)

    @checkRole(('admin',))
    def index(self):
        start = g.mpuls_config.get('job_percentage', 'start_date')
        y, m, d = start.split('-')
        y = int(y)
        m = int(m)
        d = int(d)
        percentages = []
        r = range(int(g.mpuls_config.get('job_percentage', 'months')))
        jp = JobPercentage()
        for x in r:
            sd, ed = calendar.monthrange(y, m)
            s = date(y, m, 1)
            e = date(y, m, ed)
            if date.today() < date(y, m, 1):
                break
            cases, percentage = jp.calulate_percentage(s, e)
            percentages.append((date(y, m, ed), cases, percentage))
            m += 1
            if m > 12:
                m = 1
                y += 1
        c.percentages = percentages
        c.display_jobpercentage = False
        c.jobpercentage = jp.get_job_percentage()
        if c.jobpercentage:
            c.display_jobpercentage = True

        return render('/jobpercentage/jobpercentage.mako')
