#-*- coding: utf-8 -*-
#
# Copyright 2007, 2008 Intevation GmbH, Germany, <info@intevation.de>
#
# This file is part of mpuls WASKA (CoMPUter-based case fiLeS -
# Web-Anwendungs-Server fuer Kompetenzagenturen).
#
# mpuls WASKA is free software: you can redistribute it and/or modify it under
# the terms of the GNU Affero General Public License as published by the
# Free Software Foundation, either version 3 of the License, or (at your
# option) any later version.
#
# mpuls WASKA is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public
# License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with mpuls WASKA. If not, see <http://www.gnu.org/licenses/>.
#
# mpuls WASKA has been developed on behalf of the
# Projekttraeger im Deutschen Zentrum fuer Luft- und Raumfahrt e.V. (PT-DLR)
# within the programme Kompetenzagenturen (Durchfuehrungsphase) funded by
# the Bundesministerium fuer Familie, Senioren, Frauen und Jugend and
# European Social Fund resources.
#
# Authors:
# Torsten Irländer <torsten.irlaender@intevation.de>
# Bernhard Herzog <bernhard.herzog@intevation.de>
#

from mpulsweb.lib.db import db


FETCH_ALL_NEWS = """\
SELECT id, datum, titel, nachricht, art_beschreibung
FROM ka_nachrichten_tbl_view
WHERE id NOT IN (SELECT nachrichten_id
                 FROM nm_benutzer_nachrichten_tbl_view
                 WHERE benutzer_id = getuserid())
ORDER BY datum DESC
"""


class NewsList(object):

    """List of news objects for the given user"""

    def __init__(self):
        self.list = []
        with db.cursor() as cur:
            cur.execute(FETCH_ALL_NEWS)
            for row in cur.fetchall():
                self.list.append(News(id=row[0], date=row[1], title=row[2],
                                      text=row[3], type=row[4]))

    def getList(self):
        return self.list


class News(object):

    def __init__(self, id=None, date=None, title=None, text=None, type=None):
        self.id = id
        self.date = date
        self.title = title
        self.text = text
        self.type = type


def mark_news_as_read(news_id):
    """Mark the news item given by news_id as read by the current user."""
    with db.transaction() as cur:
        cur.execute("SELECT markNewsAsRead(getuserid(), %(news_id)s)",
                    {"news_id": news_id})


# vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8:
