## -*- coding: utf-8 -*-
<%inherit file="../main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>
<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li><a href="${h.url(controller='administration', action='index')}">${_('Administration')}</a></li>
  <li><a href="${h.url(controller='administration', action='overviewUser')}">${_('User overview')}</a></li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('User overview')}
</%def>

<div id="content_header_small">
  <div id="content_ueberschrift">
 ${_('User overview')}
  </div>
  <div id="modusfield">
    <div class="actions">
      <ul>
        <li><a href="${h.url(controller='administration', action='newUser')}"> ${_('Create new user')}</a></li>
      </ul>
    </div>
  </div>
</div>
% if h.getLogin() == 'adm':
<div class="repair">
<p>Sie sind mit der initialen Anmeldekennung - adm - angemeldet. Diese
Anmeldekennung haben Sie von der Intevation GmbH bekommen.</p>

<ul>
  <li>Legen Sie eine neue BenutzerIn mit der Benutzerrolle "Administration" an.
Notieren Sie Anmeldekennung und Passwort sorgfältig! </li>
</ul>

<p>Damit haben Sie alle Aufgaben des initialen Zugangs erledigt. Die weitere
Einrichtung des Systems erfolgt mit der neuen Benutzerrolle Administration.
Melden Sie sich ab und mit der neuen Anmeldekennung wieder an, danach:</p>

<ul>
  <li> Legen Sie mindestens eine BenutzerIn mit die Benutzerrolle "Verwaltung" an.</li>
  <li> Tragen Sie die Angaben für Ihre Einrichtung ein (Name, ggf. Kennung, etc.).</li>
  <li style="margin-top: 1em"> Ggf. richten Sie eine oder mehrere Benutzergruppen ein.</li>
  <li> Ggf. legen Sie Vertretungsregeln fest.</li>
  <li> Ggf. legen Sie noch eine zweite BenutzerIn mit der Rolle Administration an,
für Ihre Entlastung.</li>
</ul>
<p>Weitere Erklärungen zu den Benutzerrollen und dem Setup finden Sie im
BenutzerInnenhandbuch.</p>
<p><a href="javascript:window.print()">Wollen Sie diese Seite ausdrucken?</a></p>
</div>
% endif
<h3>Tabelle der vorhandenen BenutzerInnen:</h3>
<div class="repair">
  <table class="table table-condensed table-hover">
   <thead>
    <tr>
      <th class="table_header_h table_width_mid">${_('Lastname')}</th>
      <th class="table_header_h table_width_mid">${_('Firstname')}</th>
      <th class="table_header_h ">${_('Role')}</th>
      <th class="table_header_h table_width_mid_s">${_('Actions')}</th>
    </tr>
   </thead>
    <% idset = 0 %>
    % for user in c.user_overview:
      % if user.login != 'adm':
        % if idset==0:
         <tr>
         <% idset = 1 %>
         % else:
         <tr>
         <% idset = 0 %>
         % endif
           <td><a href="${h.url(controller='administration', action='showUser', id=user.id)}">${user.last_name| F.NA}</a></td>
           <td><a href="${h.url(controller='administration', action='showUser', id=user.id)}">${user.first_name| F.NA}</a></td>
           ##% if user.getRole() == 'Admin':
           ##<td><img src="${h.url('/images/icons/admin_grey_tag.gif')}" alt="${_('Role Administrator')}" title="${_('Role Administrator')}"></td>
           ##% else:
           ##  <td><img src="${h.url('/images/icons/cm_grey_tag_width.gif')}" alt="${_('Role Case Manager')}" title="${_('Role Case Manager')}"></td>
           ##% endif
           <td>${user.getRole()}</td>
           <td>
             <a href="${h.url(controller='administration', action='showUser', id=user.id)}"><img src="${h.url('/images/icons/open_active_22.png')}" border="0" alt="${_('Show')}" title="${_('Show')}"></a>
             % if str(user.id) != str(session.get('USER_AUTHORIZED').id):
              <a href="${h.url(controller='administration', action='deleteUser', id=user.id)}"><img src="${h.url('/images/icons/delete_active_22.png')}" border="0" alt="${_('Delete')}" title="${_('Delete')}"></a>
             % endif
           </td>
         </tr>
      % endif
    % endfor
    % if len(c.user_overview) <= 0:
      <tr>
        <td colspan="2">
          ${_('No data found.')}
        </td>
      </tr>
    % endif
  </table>
</div>
