## -*- coding: utf-8 -*-
<%! import mpulsweb.lib.helper.filters as F %>
<%inherit file="main.mako" />

<%def name="title()">
    ${h.get_app_title()} - ${_('Loginpage')}
</%def>

## Render attribute
<%def name="maybeattr(attrname, cond)">
% if cond:
${attrname}
% endif
</%def>

## Render an option for a choice field
<%def name="option(value, desc, selected)">
<option value="${value}" ${maybeattr("selected", selected)}>${desc}</option>
</%def>



<h1>${_('%s login') % h.get_app_title()}</h1>
<div id="waska_form_login">

  % if c.login_failed:
    <div class="form_errors">
      <a name="error_list"><h1>${_('Wrong Input')}</h1></a>
      <ul>
        <li>${_('Login or Password not correct')}</li>
      </ul>
    </div>
  % endif

  <p>
    <strong>${_('Agency')}: ${h.getKAName()}</strong><br>
    ${_('Please enter identifier and password to login.')}
  </p>

  <form name="login" action="${h.url(controller='auth', action='loginAction')}" 
  accept-charset="UTF-8" method="POST">
    ${ h.csrf_token() }
    <div class="label">
      <label for="username">${_('Identifier:')}</label>
    </div>
    <div class="input">
       <input id="username" type="text" name="username" maxlength="64">
    </div>
    <div class="clearer"></div>

    <div class="label">
      <label for="password">${_('Password:')}</label>
    </div>
    <div class="input">
      <input type="password" id="password" name="password">
    </div>
    <div class="clearer"></div>

    ## This additional selection field for choosing the DB to connect to will
    ## be available as soon as there are defined databases in the dblist json
    ## file. Note that the variable c.filter is optional and defaults to None
    ## which means that no filtering is done. c.filter must be a compiled regular
    ## expression.
    % if len(h.get_db_selectionlist()) > 0 and g.mpuls_config.is_enabled('common', 'showagencychooser'):
    <div class="label">
      <label for="dbname">${_('Agency')}:</label>
    </div>
    <div class="input">
      <select name='dbname' size=1>
      <% dbs = h.get_db_selectionlist() %>
      % for db in h.get_sorted_db_from_selectionlist(c.filter):
           ${option(db, dbs.get(db).get('measure_name'), db == c.dbname)}
      % endfor
      </select>
    </div>
    % endif
    <div class="clearer"></div>
    <div class="label"><label for="submit"></label></div>
    <div class="input" id="login_btn">
      <input class="button" type="submit" value="${_('Login button')}" name="authform">
    </div>
    <div class="clearer"></div>
  </form>
</div>
