## -*- coding: utf-8 -*-
<%!

from pylons import app_globals as g
import mpulsweb.lib.helper.filters as F
import mpulsweb.lib.helpers as h
from mpulsweb.lib.translation import _
from formed.meta.document import containing_repeat_group

fields = g.case.get_overview_fields_list()

# Extend fields with default fields in overview
fields.extend([
    (_('Editor'), "bearbeiter_id", "table_name",
     ["admin"],
     lambda case: "%s, %s" % (F.NA(case.getEditor().last_name),
                              F.NA(case.getEditor().first_name[:1]))),

    (_('Updated'), "zugriff", "table_name", ["cm"],
     lambda case: h.format_date(case.state.getAccessTime())),
    ("ID", "id", "table_width_mid_s", ["cm", "admin"],
     lambda case: F.NA(case.id)),
  ])
%>

<%def name="build_list_headers()">
  <%
    # Normally CASE_OVERVIEW_SEARCHOPTIONS should contain at least the default
    # ordering fields when showing the case-overview (Set in
    # case_overview-controller). But as this template is included in other
    # use-cases too this is not always true. In theses cases be more error
    # tolerant and fallback to no (system default = id) sorting,
    # which should be ok in theses cases.
    s = session.get('CASE_OVERVIEW_SEARCHOPTIONS', {})
    sort_field = s.get('sort_field')
    sort_order = s.get('sort_order')
  %>
  % if g.mpuls_config.is_enabled('case-module', 'casebundle'):
    <th class="table_header_h table_checkbox">&nbsp;</th>
  % endif
  % for title, urlpart, style, roles, get_value in fields:
    % if h.hasRole(roles):
      <th class="${style} table_header_h">${title}
        <%
          nc = g.formedTree.name2nc.get(urlpart)
          hide_sorting = nc and containing_repeat_group(nc)
        %>
        % if not hide_sorting:
        <a href="${h.url(controller='case_overview', action='overview',
                             sort_field=urlpart, sort_order='asc')}">

            <img class   = "sorticon"
            %if sort_field == urlpart and sort_order == 'asc':
                src    = "${h.url('/images/icons/sort_asc_active.png')}"
                alt    = "${_("Sorted by %s in ascending order") % title}"
                title  = "${_("Sorted by %s in ascending order") % title}"
            %else:
                src    = "${h.url('/images/icons/sort_asc.png')}"
                alt    = "${_("Sort in ascending order")}"
                title  = "${_("Sort in ascending order")}"
            %endif
                width  = "10"
                height = "9"></a>
        <a href="${h.url(controller='case_overview', action='overview',
                             sort_field=urlpart, sort_order='desc')}">
            <img class   = "sorticon"
            %if sort_field == urlpart and sort_order == 'desc':
                src    = "${h.url('/images/icons/sort_desc_active.png')}"
                alt    = "${_("Sorted by %s in descending order") % title}"
                title  = "${_("Sorted by %s in descending order") % title}"
            %else:
                src    = "${h.url('/images/icons/sort_desc.png')}"
                alt    = "${_("Sort in descending order")}"
                title  = "${_("Sort in descending order")}"
            %endif
                width  = "10"
                height = "9"></a>
        % endif
      </th>
    % endif
  % endfor
  <th class="table_status table_header_h">
    ${_('Status')}
  </th>
  <th class="table_action table_header_h">
    ${_('Actions')}
  </th>
</%def>

<%def name="build_list_row(case)">
  % if g.mpuls_config.is_enabled('case-module', 'casebundle'):
    <td><input type="checkbox" name="case_id" value="${case.id}"></td>
  % endif
  % for title, urlpart, style, roles, get_value in fields:
    % if h.hasRole(roles):
      % if case.getState().getState() != 5 and case.getState().getState() != 3 and case.getState().getState() != 4:
        <% nc = g.formedTree.name2nc.get(urlpart) %>
        % if not nc:
            <% link_url = h.url(controller='case', action='select', id=case.id, confirmed=0) %>
        % else:
          <%
            nc_name = urlpart
            rg_nc = containing_repeat_group(nc)
            if rg_nc:
                nc_name = "group_%s" % rg_nc.getName()
            urlid = ":".join((nc_name, str(case.id)))
            link_url = h.get_formular_url(g.formedTree, urlid, nc_name)
          %>
        % endif
        <td><a href="${link_url}">${get_value(case) | F.NA}</a></td>
      % else:
        <td>${get_value(case) | F.NA}</td>
      % endif
    % endif
  % endfor
  <td>
    ${get_phase_icon(case)}
    % if g.mpuls_config.is_enabled('case-module', 'tags'):
        ${get_validity_icon(case)}
    % endif
    ${get_state_icon(case)}
    ${get_sync_icon(case)}
  </td>
  <td>
    ${get_actions(case)}
  </td>
</%def>

<%def name="get_validity_icon(case)">
  % for validity in g.mpuls_config.get('validities', 'enabled'):
    % if validity['id'] == case.getValidity():
      ##<a href="${h.url(controller='tags', action='overview', id=case.id)}">
        <img src="${h.url('/images/icons/%s' % validity['icon'])}" alt="${validity['name']}" title="${validity['name']}" width="22" height="22">
      ##</a>
    % endif
  % endfor
</%def>

<%def name="get_phase_icon(case)">
  <% phase = c.statemachine.get_current_state(case) %>
  <% phase_id = phase.get_id() %>
  <% running = not phase_id%2 and 'running' or 'finished' %>
  <% description = h.literal(phase.get_display_name()) %>
  <% icon = phase.get_icon_name() %>
  <img src="${h.url(str('/images/icons/case_status/%s_%s.png' % (icon, running)) )}" alt="${description}" title="${description}" width="22" height="22">
</%def>

<%def name="render_phase_legend()">
<div class="container widget info">
  <strong>${_('Legend')}: </strong>
  % for short_name, long_name in c.statemachine.get_state_legend():
        ${short_name}: ${long_name},
  % endfor

  | <span style="background-image:url('${h.url("/images/icons/phase-running-22.png")}'); background-repeat:no-repeat; background-position:1px -2px">
      (&nbsp;&nbsp;&nbsp;)
    </span>: ${_("Running")},
    <span style="background-image:url('${h.url("/images/icons/phase-stop-22.png")}'); background-repeat:no-repeat; background-position:1px -2px">
      (&nbsp;&nbsp;&nbsp;)
    </span>: ${_("Finished")}
</div>
<br>
</%def>

<%def name="get_sync_icon(case)">
  % if g.mpuls_config.is_enabled('case-module', 'meta-server'):
    % if case.getMeta().is_linked():
      <img src    = "${h.url('/images/icons/air-link-ok.png')}"
           border = "0"
           alt    = "${_('Case is linked with AiR-Server')}"
           title  = "${_('Case is linked with AiR-Server')}">
    % else:
      <img src    = "${h.url('/images/icons/air-link-notok.png')}"
           border = "0"
           alt    = "${_('Case is not linked with AiR-Server')}"
           title  = "${_('Case is not linked with AiR-Server')}">
    % endif
  % endif
</%def>

<%def name="get_state_icon(case)">
  % if h.hasRole(['cm']) and g.mpuls_config.is_enabled('case-module', 'organisation'):
    % if case.user_is_editor(session.get('USER_AUTHORIZED').id):
      <img src    = "${h.url('/images/icons/edit_editor.png')}"
           border = "0"
           alt    = "${_('Editor')}"
           title  = "${_('Editor')}"
           width  = "22"
           height = "22">
    % else:
      <img src    = "${h.url('/images/icons/edit_editors_22.png')}"
           border = "0"
           alt    = "${_('Standin')}"
           title  = "${_('Standin')}"
           width  = "22"
           height = "22">
    % endif
  % endif
  % if case.getState().getState() in (1,2):
    <img src    = "${h.url('/images/icons/edit_22.png')}"
         border = "0"
         alt    = "${_('Editable')}"
         title  = "${_('Editable')}"
         width  = "22"
         height = "22">
  % elif case.getState().getState() == 3:
    <img src    = "${h.url('/images/icons/delete_inactive_22.png')}"
         border = "0"
         alt    = "${_('Mark delete')}"
         title  = "${_('Mark delete')}"
         width  = "22"
         height = "22">
  % elif case.getState().getState() == 4:
    <img src    = "${h.url('/images/icons/anonymise_inactive_22.png')}"
         border = "0"
         alt    = "${_('Mark anonym')}"
         title  = "${_('Mark anonym')}"
         width  = "22"
         height = "22">
  % elif case.getState().getState() == 5:
    <img src    = "${h.url('/images/icons/anonymise_inactive_22.png')}"
         border = "0"
         alt    = "${_('Make anonymousym')}"
         title  = "${_('Make anonymousym')}"
         width  = "22"
         height = "22">
  % endif
  % if case.state.get_changed_editor():
    <img src    = "${h.url('/images/icons/edit_changed_editor.png')}"
         border = "0"
         alt    = "${_('Changed editor')}"
         title  = "${_('Changed editor')}"
         width  = "22"
         height = "22">
  % endif
</%def>

<%def name="get_actions(case)">
  % if h.hasRole(['admin']):
    % if case.getState().getState() != 5:
      <a href="${h.url(controller='case', action='select', id=case.id,
                 confirmed=0)}">
      <img src    = "${h.url('/images/icons/open_active_22.png')}"
       border = "0"
       alt    = "${_('Show')}"
       title  = "${_('Show')}"
       width  = "22"
       height = "22"></a>
    % endif
    % if case.getState().getState() in (3, 5) and g.mpuls_config.is_enabled('case-module', 'show-delete-icon'):
      <a href="${h.url(controller='case', action='delete', id=case.id,
                           confirmed=0)}">
        <img src    = "${h.url('/images/icons/delete_active_22.png')}"
             border = "0"
             alt    = "${_('Delete case')}"
             title  = "${_('Delete case')}"
             width  = "22"
             height = "22"></a>
    % endif
    % if case.getState().getState() == 4:
      % if g.mpuls_config.is_enabled('case-module', 'anonymize'):
        <a href="${h.url(controller='case', action='anonymize', id=case.id,
                             confirmed=0)}">
          <img src    = "${h.url('/images/icons/anonymise_active_22.png')}"
               border = "0"
               alt    = "${_('Anonymize case document')}"
               title  = "${_('Anonymize case document')}"
               width  = "22"
               height = "22"></a>
      % endif
    % endif
    % if case.getState().getState() in (3, 4):
      <a href="${h.url(controller='case', action='restore', id=case.id,
                           confirmed=0)}">
        <img src    = "${h.url('/images/icons/refresh_active_22.png')}"
             border = "0"
             alt    = "${_('Restore case document')}"
             title  = "${_('Restore case document')}"
             width  = "22"
             height = "22"></a>
    % endif
  % elif h.hasRole(['cm']) and case.getState().getState() in (1, 2):
    % if case.getState().getState() != 5 and  case.getState().getState() != 4:
      <a href="${h.url(controller='case', action='select', id=case.id,
                 confirmed=0)}">
      <img src    = "${h.url('/images/icons/open_active_22.png')}"
       border = "0"
       alt    = "${_('Show')}"
       title  = "${_('Show')}"
       width  = "22"
       height = "22"></a>
    % endif
    % if g.mpuls_config.is_enabled('case-module', 'anonymize'):
      <a href="${h.url(controller='case',
                           action='markForAnonymizeFromOverview', id=case.id,
                           confirmed=0)}">
        <img src    = "${h.url('/images/icons/anonymise_active_22.png')}"
             border = "0"
             alt    = "${_('Anonymize case document')}"
             title  = "${_('Anonymize case document')}"
             width  = "22"
             height = "22"></a>
    % endif
    % if g.mpuls_config.is_enabled('case-module', 'show-delete-icon'):
    <a href="${h.url(controller='case', action='markForDelete', id=case.id,
                         confirmed=0)}">
      <img src    = "${h.url('/images/icons/delete_active_22.png')}"
           border = "0"
           alt    = "${_('Delete')}"
           title  = "${_('Delete')}"
           width  = "22"
           height = "22"></a>
    % endif
  % endif
</%def>

<div class="repair">
  <input type="checkbox" name="mpuls-toggle-all-case_id"
         id="mpuls-toggle-all-case_id"
         ><label for="mpuls-toggle-all-case_id">${_('Select/deselect all cases')}</label>

  <table id="table_caseoverview" class="table table-condensed table-striped table-hover">
    <thead>
      <tr>
        ${build_list_headers()}
      </tr>
    </thead>
    <tbody>
    % for num, case in enumerate(c.cases.getDatasets()):
        <tr>
          ${build_list_row(case)}
        </tr>
    % endfor
     % if len(c.cases.getDatasets()) <= 0:
    <tr>
      <td colspan="${len(fields)+1}">
        ${_('No data found.')}
      </td>
    </tr>
    % endif
    </tbody>
  </table>
</div>
${render_phase_legend()}
