## -*- coding: utf-8 -*-
<%inherit file="main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>
<%!  import mpulsweb.lib.helper.case as C %>

<%def name="buildNavipath()">
  ${parent.buildNavipath()}
  <li><a href="${h.url(controller='case', action='select',
                           id=session['case'].id, confirmed=1)}">${_('Selected case documents')}</a></li>
  <li><a href="${h.url(controller='case', action='digest',
                           id=session['case'].id)}">${_('Summary of the case document')}</a></li>
</%def>

<%def name="title()">
    ${h.get_app_title()} - ${_('Summary of the case document')}
</%def>

<%def name="buildModusfield()">
  <div id="modusfield">
    <div class="actions">
      <ul>
        <li>
          <a href="${h.url(controller='case', action='printdigest',
                               id=session['case'].id)}"
             target="_blank"
             onclick="return checkModification();">
            ${_('Printout')}
          </a>
        </li>
      </ul>
    </div>
  </div>
</%def>

<%def name="buildContentHeader()">
</%def>

<%def name="renderCustomCaseStateInfo(case)">
  ##<tr class="">
  ##  <td class="label">Ole</td>
  ##  <td>Ole</td>
  ##</tr>
</%def>

<%def name="renderCaseInfo(case)">
  <h2>${_('Digest youth')}</h2>
  <table id="case_info">
    % for num, field in enumerate(c.case.get_digest_fields()):
      <tr class="${num % 2 and 'hl' or ''}">
        <td class="label">${c.case.get_description(field.name)}</td>
        <td>${h.convertForDigest(c.case.get_value(field.name))| F.NA}</td>
      </tr>
    % endfor
  </table>
</%def>

<%def name="renderMaxSavetimeInfo(case)">
  <div id="content_header_small">
    <div id="content_ueberschrift">
      ${_('Summary of the case document')}
    </div>
    ${self.buildModusfield()}
  </div>
  % if not c.print_version:
    % if (c.finished and c.daysToMaxSavetime < 0) or (not c.finished and c.daysToMaxSavetime <= 0):
      <div class="dialog">
        % if c.finished:
          <h1>
            <img src="${h.url('/images/icons/info/alert.png')}"
                 alt="${_('attention')}"/>
            ${_('Max save duration exceeded!')}
          </h1>
          <p>
            Nach Beendigung des Case Managements ist eine weitere
            Aufbewahrung der personenbezogenen Daten der Fallakte nur bis
            zur maximalen Speicherdauer zulässig. Die maximale
            Speicherdauer (${c.maxsavetime} Tage) wurde seit
            ${abs(c.daysToMaxSavetime)} Tagen überschritten!
            <strong>Es wird empfohlen, die Fallakte zu anonymisieren!</strong>
          </p>
        % endif
        % if not c.finished:
          <h1>
            <img src="${h.url('/images/icons/info/question.png')}"
                 alt="${_('attention')}"
                 width="48"
                 height="48">Inaktiver Fall?
          </h1>
          <p>
            Für die Fallakte konnte seit
            ${abs(c.daysToMaxSavetime)+int(c.maxsavetime)} Tagen keine
            Aktivität festgestellt werden. Bitte prüfen Sie, ob der Fall
            noch aktiv bearbeitet wird.
          </p>
        % endif
      </div>
    % else:
      <div><div id="case_last_modified">${_('Last modification')}: ${h.format_datetime(c.last_access)}</div>
        % if c.daysToMaxSavetime <= 14:
          % if c.finished or c.canceled:
            (${_('Days to exceed the max save duration')}:
             ${c.daysToMaxSavetime})
          % else:
            (${_('Days to next automatic reminder of the case document')}:
             ${c.daysToMaxSavetime})
          % endif
        % endif
      </div>
    % endif
  % endif
</%def>

<%def name="renderCaseStateInfo(case)">
  <h2>${_('Information on case')}</h2>
  <table id="case_info">
    <tr class="hl">
      <td class="label">${_('ID')}</td>
      <td>${c.case.id}</td>
    </tr>
    <% editor = c.case.getEditor() %>
    <tr class="">
      <td class="label">${_('Editor')}</td>
      <td>${editor.last_name | F.NA}, ${editor.first_name | F.NA}</td>
    </tr>
    <% casetype = g.mpuls_config.get('phases', 'casetype')[0].get(str(c.case.getState().getPhase())) %>
    % if casetype is not None:
      <tr class="">
        <td class="label">${_('Casetype')}</td>
        <td>${casetype}</td>
      </tr>
    % endif
    <tr class="hl">
      <td class="label">${_('Phase')}</td>
      <td>${h.literal(g.case_factory.get_state_machine().get_current_state(c.case).get_display_name())}</td>
    </tr>
    % if g.mpuls_config.is_enabled('case-module', 'tags'):
    <tr class="">
      <td class="label">${_('Validity')}</td>
      <td>
        % for validity in g.mpuls_config.get('validities', 'enabled'):
          % if validity['id'] == c.case.getValidity():
            ${validity['name']}
          % endif
        % endfor
      </td>
    </tr>
    % endif
    <tr class="">
      <td class="label">${_('Start and Enddates')}</td>
      <td>
        % if c.case.getState().getPhase() != -1:
          <ul>
          <% reachable = c.case.get_phaseslist().get_path(
                         str(c.case.getState().getPhase()),only_reachable=False)
          %>
          % for phase in c.case.get_phaseslist():
            <% if phase.id == "-1" and g.mpuls_config.is_enabled('phases', 'hideunknown'): continue  %>
            %  if phase.getStart().id in reachable or phase.getEnd().id in reachable:
              <li>
                ${h.literal(phase.description)}<br>
                <span class="info">
                ${_('Start date')}: ${h.format_date(phase.getStart().date) | F.NA}<br>
                ${_('End date')}: ${h.format_date(phase.getEnd().date) | F.NA}<br>
                ${_('Duration in weeks')}: ${C.phase_time_in_weeks(phase.getDuration()) | F.NA}
                </span>
              </li>
            % endif
          % endfor
          </ul>
        % else:
          ${_('unknown')}
        % endif
      </td>
    </tr>
    ${self.renderCustomCaseStateInfo(c.case)}
  </table>
</%def>

${self.body()}
