## -*- coding: utf-8 -*-
<%inherit file="../casemanagement/main.mako" />
<%!  import mpulsweb.lib.helper.filters as F %>
<h1>${_('Meta search')}</h1>
% if c.remaining_searches < 5:
  <div class="widget dialog warning-box">
    <h1><img width="48" height="48" alt="" src="/images/icons/info/info.png">${_('Attention')}!</h1>
    <p>${h.literal(_('To prevent misuse of the meta-search <u>the meta-account will be disabled after after <strong>%s</strong> more unsuccessful searches</u>. Counter will be reset on successful search or on linking a case.') % str(c.remaining_searches + 1))}</p>
  </div>
% endif
<form name="metasearch" action="${h.url(controller='meta', action='searchAction')}" method="POST">
  ${ h.csrf_token() }
  <div class="widget container">
    <table>
      <tr>
        <td class="label">${_('Birthname')}</td>
        <td><input type="text" size="30" name="birthname" maxlength="256"></td>
        <td>
          <form:error name="birthname">
        </td>
      </tr>
      <tr>
        <td class="label">${_('Firstname')}</td>
        <td><input type="text" size="30" name="firstname" maxlength="256"></td>
        <td>
          <form:error name="firstname">
        </td>
      </tr>
      <tr>
        <td class="label">${_('Birthdate')}</td>
        <td><input type="text" size="30" name="birthdate" maxlength="256"></td>
        <td>
          <form:error name="birthdate">
        </td>
      </tr>
      <tr>
        <td class="label">${_('Gender')}</td>
        <td> 
          <select name="gender">
            <option value="-1">${_('Unspecified')}</option>
            <option value="1">${_('male')}</option>
            <option value="0">${_('female')}</option>
          </select>
        </td>
        <td>
          <form:error name="gender">
        </td>
      </tr>
      <tr>
        <td class="label">${_('Firstname Mother')}</td>
        <td><input type="text" size="30" name="firstname_mother" maxlength="256"></td>
        <td>
          <form:error name="firstname_mother">
        </td>
      </tr>
      <tr>
        <td class="label">${_('Firstname Father')}</td>
        <td><input type="text" size="30" name="firstname_father" maxlength="256"></td>
        <td>
          <form:error name="firstname_father">
        </td>
      </tr>
      <tr>
        <td></td>
        <td><input type="submit" value="${_('Search')}"/></td>
        <td></td>
      </tr>
      <tr>
        <td></td>
        <td colspan="2">
          <p class="note">
          ${h.literal(_('<strong>Notice:</strong> Please enter full firstname of mother and father. If the firstname of mother or father is not known please enter "unknown".'))}
          </p>
        </td>
      </tr>
    </table>
  </div>
</form>

% if c.show_create:
  <br>
  <div class="widget container">
  % if len(c.result) <= 0:
  <h2>${_('No Meta-Cases found!')}</h2>
  <p>${_('Please make sure that you tried different spellings of the name of client to maximize the chance of finding a meta case. ')}</p>
  % else:
  <h2>${_('Meta-Cases found')}</h2>
  <p>${_('Please select one of the Meta-Cases below to link the local case with the Meta-Case.')}</p>
  % endif
  <table class="hovertable">
    <tr>
      <th width="">${_('UUID')}</th>
      <th class="actions">${_('Actions')}</th>
    </tr>
    % for num, m in enumerate(c.result):
        <tr class="${num % 2 and 'table_row_h' or 'table_row_h2'}">
          <td>${m["uuid"]}</td>
          <td class="actions">
            <a href="${h.url(controller='meta', action='link', id=m['uuid'], confirmed=0)}">
              <img src    = "${h.url('/images/icons/link_active_22.png')}"
                border = "0"
                alt    = "${_('Link')}"
                title  = "${_('Link')}"
                width  = "22"
                height = "22">
            </a>
          </td>
        </tr>
    % endfor
    % if len(c.result) <= 0:
    <tr>
      <td colspan="2">
        ${_('No data found.')}
      </td>
    </tr>
    % endif
  </table>
  </div>
  <br>
  <div class="widget container">
  <h2>${_('Create new meta case')}</h2>
  <p>${_('If you can find not find a counterpart for this case on the metas erver you can create a new one on the meta server.')}</p>
  % if not c.case.is_hashable():
    <p><strong>${_('State')}:</strong>${_('Required fields to create a new meta case are not filled out')}</p>
  %else:
    <br>
    <p><a href="${h.url(controller='meta', action='create', id=c.case.id, confirmed=0)}" class="button">${_('Create meta case')}</a></p>
  %endif
  </div>
% endif
