## -*- coding: utf-8 -*-
% if g.mpuls_config.is_enabled('case-module', 'flexible-search'):
  <%include file="./flexible_search.mako" />
% elif g.mpuls_config.is_enabled('case-module', 'search'):
  ${self.buildFormHeader()}
  <div class="widget container">
    <table>
      <%
        order_by_fields = []
        search_field_set = False
        for i in g.mpuls_config.get('case', 'fields'):
            if i.get('order_by', False):
                order_by_fields.append(i)

            if i.get('search_match', False):
                search_field_set = True
      %>

      % if search_field_set:
      <tr>
        <td class="label">${_('Search')}</td>
        <td><input type="text" size="30" name="search_str" maxlength="256"></td>
      </tr>
      % endif

      % if h.hasRole(['admin']) and g.mpuls_config.is_enabled('search', 'option-editor'):
      <tr>
        <td class="label">${_('Responsibility')}</td>
        <td>
          <select name="editor" id="editor">
            <option value="-1">${_('All users')}</option>
          % for user in c.userlist:
            <option value="${user.id}">${user.last_name}, ${user.first_name}</option>
          % endfor
          </select>
        </td>
      </tr>
      % endif
      % if h.hasRole(['admin']) and g.mpuls_config.is_enabled('search', 'option-agency'):
      <tr style="${not c.extended_search and 'display:none' or ''}">
        <td class="label"><label for="branch">${_("Branch")}</label></td>
        <td>
          <input type="text" name="branch" id="branch" maxlength="64">
        </td>
      </tr>
      % endif
      % if h.hasRole(['cm']):
        % if g.mpuls_config.is_enabled('case-module', 'organisation') and g.mpuls_config.is_enabled('search', 'option-responsibilty'):
          <tr>
            <td class="label">${_('Responsibility')}</td>
            <td colspan="2">
              <input type="checkbox" name="own" id="show_own" value="1" checked="checked">
              <label for="show_own">
                <img title="${_('Own cases')}"
                    alt="${_('Editor')}"
                    src="${h.url('/images/icons/edit_editor.png')}"
                    width="22"
                    height="22">${_('Own')} ${self.showCount(c.count_own)}
              </label><br>
              <input type="checkbox" name="standin" id="show_other" value="1" checked="checked">
              <label for="show_other">
                <img title="${_('Standin cases')}"
                    alt="Vertreter"
                    src="${h.url('/images/icons/edit_editors_22.png')}"
                    width="22"
                    height="22">${_('Standin')} ${self.showCount(c.count_standin)}
              </label>
            </td>
          </tr>
        % else:
            <input type="hidden" name="own" id="show_own" value="">
            <input type="hidden" name="standin" id="show_other" value="">
        % endif
      % endif
      % if g.mpuls_config.is_enabled('search', 'option-state'):
        <tr>
          <td class="label">${_('Status')}</td>
          <td colspan="2">
            <input type="checkbox" name="state" id="show_open" value="1">
            <label for="show_open">
              <img title="${_('Editable cases')}" alt="${_('Editable')}" src="${h.url('/images/icons/edit_22.png')}" height="22" width="22">${_('Editable cases')}</label><br>
            <input type="checkbox" name="state" id="show_markdelete" value="3" checked="checked">
            <label for="show_markdelete">
              <img title="${_('Almost deleted')}" alt="${_('Almost deleted')}" src="${h.url('/images/icons/delete_inactive_22.png')}" height="22" width="22">${_('Almost deleted')} ${self.showCount(c.count_del)}
            </label><br>
            % if g.mpuls_config.is_enabled('case-module', 'anonymize'):
              <input type="checkbox" name="state" id="show_markanonymize" value="4" checked="checked">
              <label for="show_markanonymize">
                <img title="${_('Almost anonymized')}" alt="${_('Almost anonymized')}" src="${h.url('/images/icons/anonymise_inactive_22.png')}" height="22" width="22">${_('Almost anonymized')} ${self.showCount(c.count_markanon)}
              </label><br>
              <input type="checkbox" name="state" id="show_anonymized" value="5" checked="checked">
              <label for="show_anonymized">
                <img title="${_('Anonymized')}" alt="${_('Anonymized')}" src="${h.url('/images/icons/anonymise_inactive_22.png')}" height="22" width="22">${_('Anonymized')} ${self.showCount(c.count_anon)}
              </label>
            % endif
          </td>
        </tr>
      % endif
      % if g.mpuls_config.is_enabled('search', 'option-phase'):
        <tr style="${not c.extended_search and 'display:none' or ''}">
          <td class="label">${_('Phase')}</td>
          <td>
            % for n, item in enumerate(c.statemachine.get_search_items()):
              <input type="checkbox" name="phase" id="phase_${n}" value="${item[0]}">
                <label for="phase_${n}">
                  ${item[1]}<br>
                </label>
            % endfor
          </td>
        </tr>
      % endif
      % if g.mpuls_config.is_enabled('search', 'option-date'):
      <tr style="${not c.extended_search and 'display:none' or ''}">
        <td class="label">${_('Start date')}</td>
        <td>
          <input type="text" name="sdate" value="">
        </td>
        <td>
          <form:error name="sdate">
        </td>
      </tr>
      <tr style="${not c.extended_search and 'display:none' or ''}">
        <td class="label">${_('End date')}</td>
        <td>
          <input type="text" name="edate" value="">
        </td>
        <td>
          <form:error name="edate">
        </td>
      </tr>
      % endif
      % if g.mpuls_config.is_enabled('search', 'option-federalstate'):
        <script>
        function checkAll(field)
        {
        for (i = 0; i < field.length; i++)
                field[i].checked = true ;
        }

        function uncheckAll(field)
        {
        for (i = 0; i < field.length; i++)
                field[i].checked = false ;
        }
        </script>
        <tr style="${not c.extended_search and 'display:none' or ''}">
          <td class="label">${_('Federal state')}</td>
          <td colspan="2">
            <input type="checkbox" name="mpuls-toggle-all-federal_state" value="" id="toggle-federal_state"><label for="toggle-federal_state">${_('Select/deselect all states')}</label><br>
            <table style="font-size: 0.8em">
              <tbody>
                <tr>
                  <td>
                    <input type="checkbox" checked="checked" id="BW" value="0" name="federal_state">
                    <label for="BW">${_(u'Baden-Württemberg')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="BY" value="1" name="federal_state">
                    <label for="BY">${_('Bavaria')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="BE" value="2" name="federal_state">
                    <label for="BE">${_('Berlin')}</label>
                  </td>
                    </tr>
                    <tr>
                  <td>
                    <input type="checkbox" checked="checked" id="BB" value="3" name="federal_state">
                    <label for="BB">${_('Brandenburg')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="HB" value="4" name="federal_state">
                    <label for="HB">${_('Bremen')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="HH" value="5" name="federal_state">
                    <label for="HH">${_('Hamburg')}</label>
                  </td>
                    </tr>
                    <tr>
                  <td>
                    <input type="checkbox" checked="checked" id="HE" value="6" name="federal_state">
                    <label for="HE">${_('Hesse')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="MV" value="7" name="federal_state">
                    <label for="MV">${_('Mecklenburg-Western Pomerania')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="NI" value="8" name="federal_state">
                    <label for="NI">${_('Lower Saxony')}</label>
                  </td>
                    </tr>
                    <tr>
                  <td>
                    <input type="checkbox" checked="checked" id="NW" value="9" name="federal_state">
                    <label for="NW">${_('North Rhine-Westphalia')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="RP" value="10" name="federal_state">
                    <label for="RP">${_('Rhineland-Palatinate')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="SL" value="11" name="federal_state">
                    <label for="SL">${_('Saarland')}</label>
                  </td>
                    </tr>
                    <tr>
                  <td>
                    <input type="checkbox" checked="checked" id="SN" value="12" name="federal_state">
                    <label for="SN">${_('Saxony')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="ST" value="13" name="federal_state">
                    <label for="ST">${_('Saxony-Anhalt')}</label>
                  </td>
                  <td>
                    <input type="checkbox" checked="checked" id="SH" value="14" name="federal_state">
                    <label for="SH">${_('Schleswig-Holstein')}</label>
                  </td>
                    </tr>
                    <tr>
                  <td>
                    <input type="checkbox" checked="checked" id="TH" value="15" name="federal_state">
                    <label for="TH">${_('Thuringia')}</label>
                  </td>
                </tr>
              </tbody>
            </table>
          </td>
        </tr>
      % endif
      % if g.case_search.supports_option("gender") and g.mpuls_config.is_enabled('search', 'option-gender'):
        <tr style="${not c.extended_search and 'display:none' or ''}">
          <td class="label">${_('Gender')}</td>
          <td>
            <select name="gender" id="gender">
              <option value="-2">${_('All')}</option>
              <option value="0">${_('Female')}</option>
              <option value="1">${_('Male')}</option>
              <option value="-1">${_('Unspecified')}</option>
            </select>
          </td>
          <td>
            <form:error name="gender">
          </td>
        </tr>
      % endif
        <%include file="/casemanagement/search_extra.mako" />

      % if c.extended_search and len(order_by_fields):
      </table>
        <span>&nbsp;</span>
      <table>
      %endif

      % if len(order_by_fields):
      <tr style="${not c.extended_search and 'display:none' or ''}">
          <td class="label">${_('Order by')}</td>
          <td>
          <select name="sort_field" id="sort_field">
                <option value="">${_('Other')}</option>
          % for field in order_by_fields:
               <option value="m.${field['name']}">${field['info_label']}</option>
          % endfor
          </select>
          <form:error name="sort_field">
          </td>
          <td>
            <select name="sort_order" id="sort_order">
            <option value="asc">${_('Sort in ascending order')}</option>
            <option value="desc">${_('Sort in descending order')}</option>
            </select>
            <form:error name="sort_order">
          </td>
        </tr>
      % endif
      <tr>
        <td class=""></td>
        <td></td>
        <td></td>
      </tr>
      <tr>
        <td class=""></td>
        <td colspan="2">
          <input class="button" type="submit" value="${_('Search')}">
          ${self.buildSearchExtend()}
          ${self.buildSearchReset()}
        </td>
      </tr>
    </table>
  </div>
  </form>
% endif
<%def name="showCount(num)">
  ${"(%s)" % num}
</%def>
<%def name="buildFormHeader()">
  <form method="post" name="case_search" action="#" accept-charset="UTF-8">
      ${ h.csrf_token() }
</%def>
<%def name="buildSearchReset()">
  <a href="${h.url('#')}">${_('Reset search')}</a>
</%def>
<%def name="buildSearchExtend()">
  % if c.extended_search:
    <a href="${h.url('#')}">${_('Hide extended search')}</a>
  % else:
    <a href="${h.url('#')}">${_('Show extended search')}</a>
  % endif
  ${h.getHelp('extended_search')}
</%def>
