<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet
    version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:output method="xml" encoding="UTF-8" />

    <!-- Basiert auf der mapping-jmd Datei von 13.04.2012. -->
    
    <xsl:template match="/">
        <cases formed-type="http://mpuls.intevation.de/formed/air-case/2011-09-16/15:00:00" version="5">
            <case>
                <master>
                    <rg_einrichtung>
                    <xsl:call-template name="name_programm"/>
                    <xsl:apply-templates select="cases/case/master/jmd_name"/>
                    <xsl:call-template name="support_js"/>
                    <xsl:call-template name="model_place"/>
                    <xsl:call-template name="measure_name"/>
                    <xsl:apply-templates select="cases/case/master/geburtsdatum"/>
                    <xsl:apply-templates select="cases/case/master/geschlecht"/>
                    <xsl:apply-templates select="cases/case/master/geburtsland"/>
                    <xsl:apply-templates select="cases/case/master/staatsangehoerigkeit"/>
                    <xsl:apply-templates select="cases/case/master/muttersprache"/>
                    <xsl:apply-templates select="cases/case/master/staatsangehoerigkeit_weitere"/>
                    <xsl:apply-templates select="cases/case/master/aufenthaltsstatus"/>
                    <xsl:apply-templates select="cases/case/master/zugang"/>
                    <xsl:apply-templates select="cases/case/master/aktuelle_situation"/>
                    <xsl:apply-templates select="cases/case/master/veraenderung_inst_einbindung"/>

                    <xsl:apply-templates select="cases/case/master/hoechster_schulabschluss"/>
                    <xsl:apply-templates select="cases/case/master/hoechster_berufsabschluss"/>
                    <xsl:apply-templates select="cases/case/master/art_cm_ende"/>
                    <xsl:apply-templates select="cases/case/master/abbruch_durch"/>
                    <xsl:apply-templates select="cases/case/master/gruende_abbruch_cm"/>
                    <xsl:apply-templates select="cases/case/master/phase"/>
                    <xsl:call-template name="benachteiligung"/>
                    <xsl:apply-templates select="cases/case/master/rg_ziele"/>
                    <xsl:apply-templates select="cases/case/master/aktuelle_massnahme_art"/>
                    </rg_einrichtung>
                </master>
            </case>
        </cases>
    </xsl:template>

    <xsl:template match="jmd_name">
        <name_einrichtung><xsl:value-of select="."/></name_einrichtung>
    </xsl:template>

    <xsl:template name="name_programm">
        <name_programm>Jugendmigrationsdienste</name_programm>
    </xsl:template>

    <xsl:template name="support_js">
	<support_js>1</support_js>
    </xsl:template>

    <xsl:template name="measure_name">
        <measure_name><xsl:value-of select="$agency_id"/></measure_name>
    </xsl:template>

    <xsl:template name="model_place">
        <model_place><xsl:value-of select="$agency_id"/></model_place>
    </xsl:template>

    <xsl:template match="geburtsdatum">
        <geburtsdatum><xsl:value-of select="substring(.,1,4)"/>-01-01</geburtsdatum>
    </xsl:template>
    <xsl:template match="geschlecht">
        <geschlecht><xsl:value-of select="."/></geschlecht>
    </xsl:template>

    <xsl:template match="geburtsland">
        <geburtsland><xsl:value-of select="."/></geburtsland>
    </xsl:template>

    <xsl:template match="staatsangehoerigkeit">
        <staatsbuergerschaft><xsl:value-of select="."/></staatsbuergerschaft>
    </xsl:template>

    <xsl:template match="muttersprache">
        <muttersprache><xsl:value-of select="."/></muttersprache>
    </xsl:template>

    <xsl:template match="staatsangehoerigkeit_weitere">
        <staatsbuergerschaft_weitere>
            <xsl:choose>
                <xsl:when test=". = 199">999</xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
            </xsl:choose>
        </staatsbuergerschaft_weitere>
    </xsl:template>

    <xsl:template match="aufenthaltsstatus">
        <migrationshintergrund>
	    <xsl:choose>
		<xsl:when test=". = 1">1</xsl:when>
		<xsl:when test=". = 2">1</xsl:when>
		<xsl:when test=". = 4">1</xsl:when>
		<xsl:when test=". = 5">1</xsl:when>
		<xsl:when test=". = -3">-3</xsl:when>
		<xsl:when test=". = -1">-1</xsl:when>
                <xsl:otherwise>-3</xsl:otherwise>
            </xsl:choose>
        </migrationshintergrund>
    </xsl:template>	

    <xsl:template match="zugang">
	    <zugang>
            <xsl:choose>
                <xsl:when test=". = 10">3</xsl:when>
		<xsl:when test=". = 11">6</xsl:when>
                <xsl:when test=". = -1">-1</xsl:when>
                <xsl:when test=". = 12">5</xsl:when>
                <xsl:when test=". = 13">14</xsl:when>
                <xsl:when test=". = 14">23</xsl:when>
                <xsl:when test=". = 15">22</xsl:when>
                <xsl:when test=". = 16">21</xsl:when>
                <xsl:when test=". = 17">24</xsl:when>
                <xsl:when test=". = 1">7</xsl:when>
                <xsl:when test=". = 18">10</xsl:when>
                <xsl:when test=". = 19">1</xsl:when>
                <xsl:when test=". = 20">2</xsl:when>
                <xsl:when test=". = 21">3</xsl:when>
                <xsl:when test=". = -2">-2</xsl:when>
                <xsl:when test=". = 22">88</xsl:when>
                <xsl:when test=". = 23">88</xsl:when>
                <xsl:when test=". = 24">88</xsl:when>
                <xsl:when test=". = 25">88</xsl:when>
                <xsl:when test=". = 26">88</xsl:when>
                <xsl:when test=". = 27">88</xsl:when>
                <xsl:when test=". = 28">88</xsl:when>
                <xsl:when test=". = 2">8</xsl:when>
                <xsl:when test=". = 29">13</xsl:when>
                <xsl:when test=". = 30">88</xsl:when>
                <xsl:when test=". = 3">15</xsl:when>
                <xsl:when test=". = -3">-3</xsl:when>
                <xsl:when test=". = 4">77</xsl:when>
                <xsl:when test=". = 5">77</xsl:when>
                <xsl:when test=". = 6">0</xsl:when>
                <xsl:when test=". = 7">13</xsl:when>
                <xsl:when test=". = 8">9</xsl:when>
                <xsl:when test=". = 9">11</xsl:when>
                <xsl:when test=". = 31">88</xsl:when>
                <xsl:when test=". = 32">88</xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
            </xsl:choose>
        </zugang>
    </xsl:template>

    <xsl:template match="aktuelle_situation">
        <status_eintritt>
            <xsl:choose>
                <!-- Schule -->
                <xsl:when test=". = 1">
                    <xsl:choose>
                        <xsl:when test="../aktuelle_schule = 1">10</xsl:when>  <!-- Förderschule -->
                        <xsl:when test="../aktuelle_schule = 10">10</xsl:when> <!-- Grundschule  -->
                        <xsl:when test="../aktuelle_schule = 2">10</xsl:when>  <!-- Hauptschule  -->
                        <xsl:when test="../aktuelle_schule = 3">10</xsl:when>  <!-- Realschule -->
                        <xsl:when test="../aktuelle_schule = 4">10</xsl:when>  <!-- Gesamtschule -->
                        <xsl:when test="../aktuelle_schule = 5">10</xsl:when>  <!-- Gymnasium -->
                        <xsl:when test="../aktuelle_schule = -2">11</xsl:when> <!-- sonstige Schule --> 
                        <xsl:when test="../aktuelle_schule = 6">12</xsl:when>  <!-- Berufsschule -->
                        <xsl:when test="../aktuelle_schule = 9">12</xsl:when>  <!-- Berufskolleg -->
                        <xsl:when test="../aktuelle_schule = -1">19</xsl:when> <!-- keine Angabe --> 
                        <xsl:when test="../aktuelle_schule = 7">40</xsl:when>  <!-- BVJ --> 
                        <xsl:when test="../aktuelle_schule = 8">40</xsl:when>  <!-- BGJ --> 
                    </xsl:choose>
                </xsl:when>
                <xsl:when test=". = 3">21</xsl:when>
                <xsl:when test=". = 4">24</xsl:when>
                
                <!-- Maßnahme -->
                <xsl:when test=". = 5">
                    <xsl:choose>
                        <xsl:when test="../aktuelle_massnahme_art = 1">41</xsl:when> <!-- keine Angabe -->
                        <xsl:when test="../aktuelle_massnahme_art = 1">41</xsl:when> <!-- Sonstiges -->
                        <xsl:when test="../aktuelle_massnahme_art = 1">49</xsl:when> <!-- SGB II Maßnahme -->
                        <xsl:when test="../aktuelle_massnahme_art = 1">49</xsl:when> <!-- SGB III Kurs -->
                        <xsl:when test="../aktuelle_massnahme_art = 1">49</xsl:when> <!-- SGB VIII Kurs -->
                        <xsl:when test="../aktuelle_massnahme_art = 1">41</xsl:when> <!-- GFH Kurs -->
                    </xsl:choose>
                </xsl:when>
                
                
                <xsl:when test=". = 6">33</xsl:when>
                <xsl:when test=". = 7">50</xsl:when>
                <xsl:when test=". = 8">51</xsl:when>
                <xsl:when test=". = 9">53</xsl:when>
                <xsl:when test=". = 10">34</xsl:when>
                <xsl:when test=". = 11">41</xsl:when>
                <xsl:when test=". = 12">55</xsl:when>
                <xsl:when test=". = 13">41</xsl:when>
                <xsl:when test=". = 14">-2</xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
            </xsl:choose>
        </status_eintritt>
    </xsl:template>

    <xsl:template match="veraenderung_inst_einbindung">
        <status_austritt>
            <xsl:choose>
                <!-- Keine Veränderung, wie in aktuelle_situation-->
                <xsl:when test=". = 0">
                    <xsl:choose>
                    <!-- Schule -->
                    <xsl:when test="../aktuelle_situation = 1">
                        <xsl:choose>
                            <xsl:when test="../aktuelle_schule = 1">10</xsl:when>  <!-- Förderschule -->
                            <xsl:when test="../aktuelle_schule = 10">10</xsl:when> <!-- Grundschule  -->
                            <xsl:when test="../aktuelle_schule = 2">10</xsl:when>  <!-- Hauptschule  -->
                            <xsl:when test="../aktuelle_schule = 3">10</xsl:when>  <!-- Realschule -->
                            <xsl:when test="../aktuelle_schule = 4">10</xsl:when>  <!-- Gesamtschule -->
                            <xsl:when test="../aktuelle_schule = 5">10</xsl:when>  <!-- Gymnasium -->
                            <xsl:when test="../aktuelle_schule = -2">11</xsl:when> <!-- sonstige Schule --> 
                            <xsl:when test="../aktuelle_schule = 6">12</xsl:when>  <!-- Berufsschule -->
                            <xsl:when test="../aktuelle_schule = 9">12</xsl:when>  <!-- Berufskolleg -->
                            <xsl:when test="../aktuelle_schule = -1">19</xsl:when> <!-- keine Angabe --> 
                            <xsl:when test="../aktuelle_schule = 7">40</xsl:when>  <!-- BVJ --> 
                            <xsl:when test="../aktuelle_schule = 8">40</xsl:when>  <!-- BGJ --> 
                        </xsl:choose>
                    </xsl:when>
                    <xsl:when test="../aktuelle_situation = 3">21</xsl:when>
                    <xsl:when test="../aktuelle_situation= 4">24</xsl:when>

                    <!-- Maßnahme -->
                    <xsl:when test="../aktuelle_situation = 5">
                        <xsl:choose>
                            <xsl:when test="../aktuelle_massnahme_art = 1">41</xsl:when> <!-- keine Angabe -->
                            <xsl:when test="../aktuelle_massnahme_art = 1">41</xsl:when> <!-- Sonstiges -->
                            <xsl:when test="../aktuelle_massnahme_art = 1">49</xsl:when> <!-- SGB II Maßnahme -->
                            <xsl:when test="../aktuelle_massnahme_art = 1">49</xsl:when> <!-- SGB III Kurs -->
                            <xsl:when test="../aktuelle_massnahme_art = 1">49</xsl:when> <!-- SGB VIII Kurs -->
                            <xsl:when test="../aktuelle_massnahme_art = 1">41</xsl:when> <!-- GFH Kurs -->
                        </xsl:choose>
                    </xsl:when>


                    <xsl:when test="../aktuelle_situation = 6">33</xsl:when>
                    <xsl:when test="../aktuelle_situation = 7">50</xsl:when>
                    <xsl:when test="../aktuelle_situation = 8">51</xsl:when>
                    <xsl:when test="../aktuelle_situation = 9">53</xsl:when>
                    <xsl:when test="../aktuelle_situation = 10">34</xsl:when>
                    <xsl:when test="../aktuelle_situation = 11">41</xsl:when>
                    <xsl:when test="../aktuelle_situation = 12">55</xsl:when>
                    <xsl:when test="../aktuelle_situation = 13">41</xsl:when>
                    <xsl:when test="../aktuelle_situation = 14">-2</xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="../aktuelle_situation"/>
                    </xsl:otherwise>
                </xsl:choose>
                </xsl:when>
                
                <!-- Veränderung, aus "Wenn ja, wie ist der junge Mensch aktuell eingebunden?" rauslesen-->
                <xsl:when test=". = 1">
                    <xsl:choose>
                        <xsl:when test="../ende_inst_einbindung = 1">10</xsl:when> <!-- Förderschule -->
                        <xsl:when test="../ende_inst_einbindung = 2">10</xsl:when> <!-- Hauptschule -->
                        <xsl:when test="../ende_inst_einbindung = 3">10</xsl:when> <!-- Realschule -->
                        <xsl:when test="../ende_inst_einbindung = 4">10</xsl:when> <!-- Gesamtschule -->
                        <xsl:when test="../ende_inst_einbindung = 5">10</xsl:when> <!-- Gymnasium -->
                        <xsl:when test="../ende_inst_einbindung = 6">12</xsl:when> <!-- Berufsschule -->
                        <xsl:when test="../ende_inst_einbindung = 7">40</xsl:when> <!-- Berufsvorbereitungsjahr  (BVJ) -->
                        <xsl:when test="../ende_inst_einbindung = 8">40</xsl:when> <!-- Berufsgrundbildungsjahr (BGJ) -->
                        <xsl:when test="../ende_inst_einbindung = 9">21</xsl:when> <!-- betriebliche Ausbildung -->
                        <xsl:when test="../ende_inst_einbindung = 10">24</xsl:when> <!-- außerbetriebliche Ausbildung -->
                        <xsl:when test="../ende_inst_einbindung = 19">-2</xsl:when> <!-- Praktikum -->
                        <xsl:when test="../ende_inst_einbindung = 16">55</xsl:when> <!-- Studium -->
                        <xsl:when test="../ende_inst_einbindung = 11">33</xsl:when> <!-- Erwerbstätig -->
                        <xsl:when test="../ende_inst_einbindung = 18">34</xsl:when> <!-- Selbstständig -->
                        <xsl:when test="../ende_inst_einbindung = 12">49</xsl:when> <!-- Maßnahme -->
                        <xsl:when test="../ende_inst_einbindung = 17">50</xsl:when> <!-- Arbeitslos -->
                        <xsl:when test="../ende_inst_einbindung = 13">51</xsl:when> <!-- Elternzeit -->
                        <xsl:when test="../ende_inst_einbindung = 14">-2</xsl:when> <!-- Strafvollzug -->
                        <xsl:when test="../ende_inst_einbindung = 15">53</xsl:when> <!-- Zivildienst / Wehrpflicht / Freiwilligenjahr -->

                        <xsl:otherwise>
                            <xsl:value-of select="../ende_inst_einbindung"/>
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:when>
                
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
            </xsl:choose>
        </status_austritt>
    </xsl:template>
    
    <xsl:template match="hoechster_schulabschluss">
	<hoechster_abschluss_schule>
	    <xsl:choose>
                <xsl:when test=". = 0">1</xsl:when>
                <xsl:when test=". = 1">2</xsl:when>
                <xsl:when test=". = 2">3</xsl:when>
                <xsl:when test=". = 3">4</xsl:when>
                <xsl:when test=". = 4">5</xsl:when>
                <xsl:when test=". = 5">6</xsl:when>
                <xsl:when test=". = 6">7</xsl:when>
                <xsl:when test=". = 7">8</xsl:when>
                <xsl:when test=". = 8">9</xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
	    </xsl:choose>	
	</hoechster_abschluss_schule>
    </xsl:template>

    <xsl:template match="hoechster_berufsabschluss">
	<hoechster_abschluss_beruf>
	    <xsl:choose>
                <xsl:when test=". = 0">1</xsl:when>
                <xsl:when test=". = 1">2</xsl:when>
                <xsl:when test=". = 2">3</xsl:when>
                <xsl:when test=". = 3">4</xsl:when>
                <xsl:when test=". = 4">5</xsl:when>
                <xsl:when test=". = 5">6</xsl:when>
                <xsl:when test=". = 6">7</xsl:when>
                <xsl:when test=". = 7">-2</xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
	    </xsl:choose>	
	</hoechster_abschluss_beruf>
    </xsl:template>

    <xsl:template match="art_cm_ende">
        <art_beendigung>
            <xsl:value-of select="."/>
        </art_beendigung>
    </xsl:template>

    <xsl:template match="abbruch_durch">
        <abbruch_durch>
            <xsl:choose>
                <xsl:when test=". = 1">1</xsl:when>
                <xsl:when test=". = 2">2</xsl:when>
                <xsl:when test=". = 3">4</xsl:when>
                <xsl:when test=". = 4">-2</xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
            </xsl:choose>
        </abbruch_durch>
    </xsl:template>

    <xsl:template match="gruende_abbruch_cm">
        <abbruch_grund>
            <xsl:choose>
                <xsl:when test=". = 1">10</xsl:when>
                <xsl:when test=". = 2">4</xsl:when>
                <xsl:when test=". = 3">5</xsl:when>
                <xsl:when test=". = 4">6</xsl:when>
                <xsl:when test=". = 5">2</xsl:when>
                <xsl:when test=". = 6">3</xsl:when>
                <xsl:when test=". = 7">7</xsl:when>
                <xsl:when test=". = 8">-2</xsl:when>
                <xsl:otherwise>
                    <xsl:value-of select="."/>
                </xsl:otherwise>
            </xsl:choose>
        </abbruch_grund>
    </xsl:template>

    <xsl:template name="zeitraum">
        <xsl:param name="title"/>
        <xsl:param name="finished"/>
        <xsl:param name="start"/>
        <xsl:param name="end"/>
        <rg_zeitraum>
            <zeitraum_phase><xsl:value-of select="$title"/></zeitraum_phase>
            <datum_zeitraum_start><xsl:value-of select="$start"/></datum_zeitraum_start>
            <xsl:if test="$end != '' and $finished">
                <datum_zeitraum_ende><xsl:value-of select="$end"/></datum_zeitraum_ende>
            </xsl:if>
        </rg_zeitraum>
    </xsl:template>

    <xsl:template match="phase">
        <xsl:variable name="phase" select="."/>
        <xsl:if test=". >= 0">
            <xsl:call-template name="zeitraum">
                <xsl:with-param name="title" select="'Eingangsanamnese'"/>
                <xsl:with-param name="finished" select=". > 0"/>
                <xsl:with-param name="start" select="/cases/case/master/datum_ea_start"/>
                <xsl:with-param name="end" select="/cases/case/master/datum_ea_ende"/>
            </xsl:call-template>
        </xsl:if>
        <xsl:if test=". >= 2 and . &lt; 4">
            <xsl:call-template name="zeitraum">
                <xsl:with-param name="title" select="'Case-Management'"/>
                <xsl:with-param name="finished" select=". > 2"/>
                <xsl:with-param name="start" select="/cases/case/master/datum_cm_start"/>
                <xsl:with-param name="end" select="/cases/case/master/datum_cm_ende"/>
            </xsl:call-template>
        </xsl:if>
        <xsl:if test=". >= 4">
            <xsl:call-template name="zeitraum">
                <xsl:with-param name="title" select="'Nachbetreuung'"/>
                <xsl:with-param name="finished" select=". > 4"/>
                <xsl:with-param name="start" select="/cases/case/master/datum_ber_start"/>
                <xsl:with-param name="end" select="/cases/case/master/datum_ber_ende"/>
            </xsl:call-template>
        </xsl:if>
    </xsl:template>

    <xsl:template name="benachteiligung">
        <!-- "ethnisch/kultureller Hintergrund" always set in JMD cases -->
        <rg_benachteiligung>
            <benachteiligung_bereich>5</benachteiligung_bereich>
        </rg_benachteiligung>
        
	<xsl:if test="//physische_beeintraechtugung = 1">
            <rg_benachteiligung>
                <benachteiligung_bereich>6</benachteiligung_bereich>
            </rg_benachteiligung>
        </xsl:if>
	<xsl:if test="//psychische_beeintraechtigung = 1">
            <rg_benachteiligung>
                <benachteiligung_bereich>7</benachteiligung_bereich>
            </rg_benachteiligung>
        </xsl:if>
    </xsl:template>

    <xsl:template match="aktuelle_massnahme_art">
        <xsl:if test=". = 1">
            <rechtskreis_austritt_sgbii>1</rechtskreis_austritt_sgbii>  
        </xsl:if>
        <xsl:if test=". = 2">
            <rechtskreis_austritt_sgbiii>1</rechtskreis_austritt_sgbiii>  
        </xsl:if>
        <xsl:if test=". = 5">
            <rechtskreis_austritt_sgbviii>1</rechtskreis_austritt_sgbviii>  
        </xsl:if>
        <xsl:if test=". = 4">
            <rechtskreis_austritt_sonstiges>1</rechtskreis_austritt_sonstiges>  
        </xsl:if>
    </xsl:template>


    <xsl:template match="rg_ziele">
    <rg_ua>
        <ua_titel>Unterstützungsangebot</ua_titel>
        <xsl:apply-templates select="fp_ziel"/>
        <xsl:call-template name="datum_ua_start"/>
        <xsl:call-template name="datum_ua_ende"/>
        <xsl:apply-templates select="fp_ziel_erreicht"/>
    </rg_ua>
    </xsl:template>

    <xsl:template match="fp_ziel">
        <ua_art>
            <xsl:choose>
            <xsl:when test=". = 1">8</xsl:when>
            <xsl:when test=". = 2">1</xsl:when>
            <xsl:when test=". = 3">7</xsl:when>
            <xsl:when test=". = 4">6</xsl:when>
            <xsl:when test=". = 5">3</xsl:when>
            <xsl:when test=". = 6">4</xsl:when>
            <xsl:when test=". = 7">5</xsl:when>
            <xsl:otherwise><xsl:value-of select="."/></xsl:otherwise>
            </xsl:choose>
        </ua_art>
    </xsl:template>
    
    <xsl:template name="datum_ua_start">
        <xsl:for-each select="//ua_uziel1_datum_start | //ua_uziel2_datum_start | //ua_uziel3_datum_start | //ua_uziel4_datum_start | //ua_uziel5_datum_start">
          <xsl:sort data-type="text" order="ascending" />
          <xsl:if test="position()=1">
              <datum_ua_start><xsl:value-of select="."/></datum_ua_start>
          </xsl:if>
        </xsl:for-each>
    </xsl:template>

    <xsl:template name="datum_ua_ende">
        <xsl:for-each select="//ua_uziel1_datum_ende | //ua_uziel2_datum_ende | //ua_uziel3_datum_ende | //ua_uziel4_datum_ende | //ua_uziel5_datum_ende">
          <xsl:sort data-type="text" order="descending" />
          <xsl:if test="position()=1">
              <datum_ua_ende><xsl:value-of select="."/></datum_ua_ende>
          </xsl:if>
        </xsl:for-each>
    </xsl:template>

    <xsl:template match="fp_ziel_erreicht">
        <ua_zielerreichung>
            <xsl:choose>
                <xsl:when test=". = 1">1</xsl:when>
                <xsl:when test=". = 0">2</xsl:when>
                <xsl:otherwise><xsl:value-of select="."/></xsl:otherwise>
            </xsl:choose>
        </ua_zielerreichung>
    </xsl:template>

    <xsl:template match="node()"/>
</xsl:stylesheet>
