# -*- coding: utf-8 -*-
# Copyright (C) 2012 by Intevation GmbH
# Authors:
# Bernhard Herzog <bh@intevation.de>

import unittest

from support import FormedTreeMixin


class TestDocumentPageFields(FormedTreeMixin, unittest.TestCase):

    formedtree = """\
<?xml version="1.0" encoding="UTF-8"?>
<document>
  <case>
    <page description="A Page" name="page-1">
      <group name="normalfields" description="Normal Fields">
        <text description="Text 1" name="text1"/>
        <textarea description="Text 2" name="text2"/>
        <int description="Float 1" name="float1"/>
        <float description="Float 1" name="float1"/>
        <date description="Date 1" name="date1"/>
        <rule name="rule-1" expr="1 2 +"/>
        <radio-matrix description="Matrix 1" name="matrix1">
          <radio description="Radio in Matrix" name="radio_in_matrix">
            <bool description="1" name="bool-1" value="1" checked="true"/>
            <bool description="2" name="bool-2" value="2"/>
          </radio>
        </radio-matrix>
        <choice description="Choice 1" name="choice1">
          <bool description="Keine Angabe" name="bool-229" value="-1"
                checked="true"/>
        </choice>
      </group>
      <group name="nonfields" description="Non-Fields">
        <info description="An info field" name="info1"/>
        <info name="info2">
          Info field with inline text and an expr: <expr expr="123"/>
        </info>
      </group>
      <group name="fieldlike" description="Field-Like Elements">
        <reference description="Reference" name="reference-1" ref="date1"/>
        <virtual description="Virtual field" expr="1970 1 1 date"
                 name="virtualdate"/>
      </group>
    </page>
  </case>
  <logbook>
  </logbook>
</document>
"""

    def test_page_fields(self):
        self.assertEquals([nc.getName()
                           for nc in self.meta_tree.page_fields["page-1"]],
                          [u'text1', u'text2', u'float1', u'float1', u'date1',
                           u'radio_in_matrix', u'choice1', u'reference-1'])
